
/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"


#include "globals.h"
#include "boomheader.h"
#include "boomwavelets.h"


extern void boomdelay(void), boomimp(void), boomk(void);
extern void boomrc(void), boomrho(void), boomsig(void), boomv(void);
extern void boomfree(double ***);

extern void readslice_checkscales(void);

double vfluid, vsand, vshale;
double rhofluid, rhosand, rhoshale;
double nu, phi;

void boom(char need)
{
  int i;

  if (-1 == slice) return;

  if (movie && k[slice]) {
    boomfree(&k[slice]);
    boomfree(&cond[slice]);
    boomfree(&delay[slice]);
    boomfree(&imped[slice]);
    boomfree(&rc[slice]);
    boomfree(&rho[slice]);
    boomfree(&v[slice]);
  }
  
  boomk();
  boomv();
  boomrho();
  boomimp();
  boomrc();
  boomdelay();

  if (!wave[funcmode].init) {
    wave[funcmode].val = (double *) calloc(2 * SIGPTS + 1, sizeof(double));
    for (i = -SIGPTS; i <= SIGPTS; ++i)
      wave[funcmode].val[i + SIGPTS] = (wave[funcmode].func)(i * SIGINV);
    wave[funcmode].init = True;
  }

  if ('S' == need)
    boomsig();

  readslice_checkscales();  /* if maxes / mins have changed, may need to
			       reset values in parameters window */
}




