/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"
#include "boomheader.h"


void boomalloc(double ***array)
{
  int n;
  
  (*array) = (double **) calloc(nnodes, sizeof(double **));
  
  for (n = 0; n < nnodes; ++n)
    (*array)[n] = (double *) calloc(timeloop[slice], sizeof(double));
}


void boomfree(double ***array)
{
  int n;

  if (!*array) return;

  for (n = 0; n < nnodes; ++n)
    free((*array)[n]);

  free(*array);

  *array = NULL;
}
