/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"
#include "boomheader.h"


/* refigure for changes in vfluid, vsand, vshale
   don't call when slice == -1 */


double **delay[NSLICES];      /* delay[slice][node][layer] */

void boomdelay()
{
  int n, layer, top;
  double d, x, sea;

  if (!delay[slice])
    boomalloc(&delay[slice]);

  top = timeloop[slice] - 1;

  sea = sealevel[top];

  for (n = 0; n < nnodes; ++n) {
    if ((x = (sea - timeline[slice][0][top][n])) > 0) 
      d = x / vfluid; 
    else 
      d = 0;
    delay[slice][n][top] = 2 * d;
    
    for (layer = top - 1; layer >= 0; --layer) {
      d += ((timeline[slice][0][layer + 1][n] - timeline[slice][0][layer][n]) /
	    v[slice][n][layer + 1]);
      delay[slice][n][layer] = 2 * d;
    }
  }
} 

double depthtotime(double x, int n)   /* depth, node */
{
  int top = timeloop[slice] - 1;
  int layer;
  double z;
  
  if (x > timeline[slice][0][top][n])
    return (-1000.0 / nu);

  if (x < timeline[slice][0][0][n])
    return (delay[slice][n][0] + 
	    2 * (timeline[slice][0][0][n] - x) / v[slice][n][0]);
  
  for (layer = top - 1; x < timeline[slice][0][layer][n]; --layer);
  /*   elev(layer) <= x <= elev(layer + 1)  */
  if ((z = 
       (timeline[slice][0][layer + 1][n] - timeline[slice][0][layer][n])) > 0)
    return 
      ((delay[slice][n][layer] * (timeline[slice][0][layer + 1][n] - x)
	+ delay[slice][n][layer + 1] * (x - timeline[slice][0][layer][n])) 
       / z);
  else
    return delay[slice][n][layer];
}

