/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"



#define SIGPTS 50  /* actually, half of (#pts - 1); [-1, 0) + {0} + (0, 1] */
#define SIGINV (1.0 / (double)SIGPTS)

#define FUNCS 2


extern double vfluid, vsand, vshale;
extern double rhofluid, rhosand, rhoshale;
extern double nu, phi;

extern int funcmode;
extern double maxsig[NSLICES][FUNCS][2];

extern double **delay[NSLICES];
extern double **k[NSLICES], **cond[NSLICES];
extern double **v[NSLICES];
extern double **rho[NSLICES];
extern double **imped[NSLICES];
extern double **rc[NSLICES];
extern double **sig[NSLICES][FUNCS];

extern Boolean sigmode;

typedef struct {
  double (*func)();
  Boolean init;
  double *val;  /* [2 * SIGPTS + 1] */
} Wave;
extern Wave wave[];

extern double rickerdisp(double);
extern double rickervel(double);

extern void boomalloc(double ***);
extern void signalends(void);
