

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"
#include "boomheader.h"


/* refigure for changes in vfluid, vsand, vshale, rhofluid, rhosand, rhoshale;
   call only AFTER boomv() and/or boomrho() are called (as needed);
   don't call when slice == -1 */


/* [slice][node][layer] */
double **imped[NSLICES];

double waterimped; 

void boomimp()
{
  int n, layer;
  double max, min;

  if (!imped[slice])
    boomalloc(&imped[slice]);

  min = max = rho[slice][0][0] * v[slice][0][0];

  for (n = 0; n < nnodes; ++n)
    for (layer = 0; layer < timeloop[slice]; ++layer) {
      imped[slice][n][layer] = rho[slice][n][layer] * v[slice][n][layer];
      if (imped[slice][n][layer] > max)
	max = imped[slice][n][layer];
      else if (imped[slice][n][layer] < min)
	min = imped[slice][n][layer];
    }

  waterimped = vfluid * rhofluid;

  datascale[IMPED][0].end[0][slice] = min;
  datascale[IMPED][0].end[1][slice] = max;
}
