

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"
#include "boomheader.h"

/* refigure for changes in vfluid, vsand, vshale, rhofluid, rhosand, rhoshale;
   call only AFTER boomimp();
   don't call when slice == -1 */


extern double waterimped;
 
double **rc[NSLICES];            /* [slice][node][layer] */

void boomrc()
{
  int n, layer, top;

  top = timeloop[slice] - 1;

  if (!rc[slice])
    boomalloc(&rc[slice]);

  for (n = 0; n < nnodes; ++n) {
    if (timeline[slice][0][top][n] < sealevel[top])
      rc[slice][n][top] = 
	(waterimped - imped[slice][n][top]) /
	  (waterimped + imped[slice][n][top]);
    else
      rc[slice][n][top] = 0;

    for (layer = 0; layer < top; ++layer)
      rc[slice][n][layer] = 
	(imped[slice][n][layer + 1] - imped[slice][n][layer]) /
	  (imped[slice][n][layer + 1] + imped[slice][n][layer]);
  }
}
			     
