

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"
#include "boomheader.h"

/* refigure when rhofluid, rhosand, or rhoshale change;
   don't call when slice == -1 */

extern void boomk(void);

double **rho[NSLICES];         /* rho[slice][node][layer] */

void boomrho()
{
  int n, i, deltrho;
  double max, min;
  
  if (!rho[slice]) 
    boomalloc(&rho[slice]);
  
  if (!k[slice]) boomk();
  
  min = rhosand + rhoshale + rhofluid;
  max = 0;
  
  deltrho = rhosand - rhoshale;
  
  for (n = 0; n < nnodes; ++n)
    for (i = 0; i < timeloop[slice]; ++i) { 
      rho[slice][n][i] = 
	(rhoshale + 
	 k[slice][n][i] * deltrho) * (1- timeline[slice][1][i][n]) +
	   rhofluid * timeline[slice][1][i][n];
      if (rho[slice][n][i] > max) 
	max = rho[slice][n][i];
      if (rho[slice][n][i] < min)
	min = rho[slice][n][i];
    }
  
  datascale[DENSITY][0].end[0][slice] = min;
  datascale[DENSITY][0].end[1][slice] = max;
}



