

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"
#include "boomheader.h"


/* refigure when vfluid, vsand, or vshale changes;
   don't call when slice == -1 */

extern void boomk(void);

double **v[NSLICES];         /* v[slice][node][layer] */

void boomv()
{
  int n, layer, deltv;
  double max, min;

  if (!v[slice]) boomalloc(&v[slice]);
  
  if (!k[slice]) boomk();

  min = vsand + vshale + vfluid;
  max = 0;

  deltv = vsand - vshale;

  for (n = 0; n < nnodes; ++n)
    for (layer = 0; layer < timeloop[slice]; ++layer) {
      v[slice][n][layer] = 
	1 / (
	     (timeline[slice][1][layer][n] / vfluid) + 
	     ((1 - timeline[slice][1][layer][n]) / 
	      (vshale + k[slice][n][layer] * deltv)));
      if (v[slice][n][layer] > max)
	max = v[slice][n][layer];
      if (v[slice][n][layer] < min)
	min = v[slice][n][layer];
    }
  
  datascale[VELOCITY][0].end[0][slice] = min;
  datascale[VELOCITY][0].end[1][slice] = max;
}
