

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"


/* print short syntax or longer summary and exit */

void friendly(int which)
{
  printf("\n\
Strata version %g:  plotbasin\n\
Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, and J. E. Morris.\n\
Plotbasin and the rest of Strata come with ABSOLUTELY NO WARRANTY.  See the\n\
License help entry for details.\n\
This is free software, and you are welcome to redistribute it under certain\n\
conditions; please see the Gnu General Public License, of which you should\n\
have copies in the user manual and the source code, for details.\n\n",
	 STRATA_VERSION);

  if (which > 0) {
    printf("Usage:  plotbasin <library> [-p <paramfiles>]\n");
    printf("\"plotbasin\" for syntax; \"plotbasin help\" for summary.\n\n");
    
    if (which > 1) {
      printf("Description\n");
      printf("\
Plotbasin is used to view the output of the basin simulator program simbasin.\n\
It uses the simulator's outputs --- <library>dat.out, <library>s.out, and\n\
<library>1.out thru <library>6.out.\n\
\n\
To run, \"plotbasin <library name> [options].\"  For example, to use a library\n\
named \"runex.dat\" that is in the directory above your current directory, type\n\
\"plotbasin ../runex\" to start.   \"plotbasin\" by itself will give you the\n\
command syntax, \"plotbasin help\" will give you this description.  Using\n\
\"plotbasin ../runex\" requires the files ../runexdat.out, ../runexs.out,\n\
../runex1.out, etc, to be there (they should be the output of the simulator).\n\
\n\
Options:  the currently supported option is -p, used to declare \n\
parameter files to load at startup, as in\n\
plotbasin <library> -p my.nice.parameters my.other.parameters\n\
\n\
All parameters have default values hardwired into the program.  These\n\
may be changed in the parameters window, accessed via the \n\
'parameters' button.  The window allows saving and loading of \n\
parameters.  Invoking plotbasin with -p file1 file2... reads \n\
parameter values from file1, then file2, etc, and uses them to \n\
override the default values.  Later values override earlier ones, \n\
both within a file and among files.  Entries of the format \n\
<parameter name> <parameter value> will be accepted, where \n\
<parameter name> is _exactly_ the string displayed in the parameter \n\
window for that parameter, including ':'s etc, and <parameter value>\n\
is a real number.  All other lines in parameter files will be \n\
ignored.  Parameter files which do not exist will be ignored.  The \n\
best way to make a parameter file is to use the 'save' button on the \n\
parameter window and edit the resulting file with your favorite text \n\
editor if desired.  Any parameters not overridden by such parameter \n\
files will remain at the default values.  All this only applies to \n\
the parameters found in the parameter window; these can all be \n\
changed while running regardless of how the initial values are \n\
obtained. Parameter files can also be read in with the parameter \n\
window's 'load' button.\n");
    }    
    exit(0);
  }
}
