/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"
#include <math.h>


XImage *image_gifdump;

int getpix(int x, int y)
{
  return XGetPixel(image_gifdump, x, y);
}

extern GIFEncode(FILE *, int, int, Boolean, int, int, 
		 int *, int *, int *, int f(int, int));
extern gif_reset_inits(void);


extern int screenint, screendepth;
extern Colormap cmap;

int *palette[3];
Boolean palinit = False;

Window rootwin = (Window)NULL;
int displaywidth = 0, displayheight = 0;

/* Pixmap NULL if should take from win */
void gifdump(Window win, Pixmap pmap, FILE *fp, 
	     Dimension width, Dimension height)
{
  int gifheight, gifwidth;
  int i, n, gifx, gify, bw;
  XColor col[300];
  Window dummy;
  Drawable gifsource;
  XWindowAttributes winattrib;

  if (pmap) {
    gifsource = pmap;
    gifx = 0;
    gify = 0;
    gifwidth = width;
    gifheight = height;
  }
  else {
    if (!rootwin)
      rootwin = RootWindow(display, screenint);
    if (!displaywidth)
      displaywidth = DisplayWidth(display, screenint);
    if (!displayheight)
      displayheight = DisplayHeight(display, screenint);

    XGetWindowAttributes(display, win, &winattrib);
    XTranslateCoordinates(display, win, rootwin, 0, 0, &gifx, &gify, &dummy);
    gifwidth = winattrib.width;
    gifheight = winattrib.height;
    bw = winattrib.border_width;
    gifx -= bw;
    gify -= bw;
    gifwidth += (2 * bw);
    gifheight += (2 * bw);

    /* clip to window */
    if (gifx < 0) gifwidth += gifx, gifx = 0;
    if (gify < 0) gifheight += gify, gify = 0;
    if (gifx + gifwidth > displaywidth) gifwidth = displaywidth - gifx;
    if (gify + gifheight > displayheight) gifheight = displayheight - gify;

    gifsource = rootwin;
  }

  image_gifdump = XGetImage(display, gifsource, gifx, gify, 
			    gifwidth, gifheight, AllPlanes, ZPixmap); 
  
  if (!palinit) {
    n = pow(2.0, (double)screendepth);
    for (i = 0; i < 3; ++i)
      palette[i] = (int *) XtCalloc(n, sizeof(int));
    for (i = 0; i < n; ++i) 
      col[i].pixel = i;
    XQueryColors(display, cmap, col, n);
    for (i = 0; i < n; ++i) {
      palette[0][i] = col[i].red;
      palette[1][i] = col[i].green;
      palette[2][i] = col[i].blue;
    }
    palinit = True;  
  }
  
  GIFEncode(fp, gifwidth, gifheight, False, 0, screendepth, 
	    palette[0], palette[1], palette[2], getpix);
  gif_reset_inits();
  
  XDestroyImage(image_gifdump); 
}
