

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"


/* Ask for confirmation of exit; if confirmed, exit nicely, otherwise abort */

extern void movie_cleanup(void);
extern Boolean need_to_free;  /* from readspecs.c */

void goodbye(Widget widget, XtPointer clientData, XtPointer callData)
{ 
  void freespecs();  /* defined in readspecs.c */
  

  if (!XjMessenger(widget, "Exit program?", True, NULL, NULL, NULL, NULL)) 
    return;

  if (movie)
    movie_cleanup();

  XtDestroyWidget(toplevel);
  XtDestroyApplicationContext(app);
  XFlush(display);

  if (need_to_free) freespecs();

  exit(0); 
}
