

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"
 
#include "globals.h"
#include <math.h>


	/* take a water depth (should be average of those at the four    */
	/* pts around the rectangle to be colored by colorspace())       */
	/* and scale it to a number between 0 and 1, which will be       */
	/* how far along the colorbar the rectangle is.  Negative        */
	/* depths get scaled by some power to the range [0, mid], and    */
	/* positive depths get scaled by an (independant) power to       */
	/* the range [mid, 1].  Scaling is by highest and deepest depth  */
        /* of the slice, or between the user's artificial values if the  */
        /* 'scale' is on for water depth.  Mid starts at .3.             */

double mapfacies(double x, int log)
{
  double xmin, xmax, y, rmin, rmax, n;
  Datascale fs;

  fs = datascale[FACIES][0];  /* assumes only one subtype */

  if (x < 0)
    xmin = -(fs.scaled[log] ? fs.use[0] : fs.end[0][slice]), xmax = 0, 
    n = fs.power[0], rmin = 0, rmax = fs.boundary;
  else
    xmin = 0, xmax = (fs.scaled[log] ? fs.use[1] : fs.end[1][slice]), 
    n = fs.power[1], rmin = fs.boundary, rmax = 1;

  y = pow(((x - xmin) / (xmax - xmin)), (double) n);
  
  return (rmin + y * (rmax - rmin));
}
