 

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"
#include <math.h>
#include <unistd.h>

extern void dump_canvas(Boolean, String);
extern void movie_cleanup(void);
extern void readslice_checkscales(void);
extern void readslice_init(void);
extern void readslice_readnums(FILE *);
extern void readslice_usenums(void);
extern void readspecs(void);
extern void slices(Widget);
extern void specfile(String);


int nframes;  /* read in start.c; printed by generator */
int sock;
Boolean movie;

void movieloop(Widget slicelist, XtPointer callData, XtPointer clientData)
{
  XEvent event;
  int n, ndig;
  char temp[1000];
  FILE *fp;

  if (frozen) return;  /* well, it's gotta do *something*... could unset */

  /* tell simulator it can start */
  write(sock, "s", 1);

  ndig = (int) floor(log10((double)nframes)) + 1;  /* # digits */

  /* make a .specs file of possibly-relevant params etc */
  specfile(library); 
  
  readslice_init();

  /* simulator writes a "p" to indicate the plotter should plot, and
     a "q" to indicate it should quit */
  n = 0;
  while (read(sock, temp, 1) == 1 && temp[0] != 'q') {
    ++n;

    /* need this, or Sync */
    XFlush(display);
    while (XCheckMaskEvent(display, ExposureMask, &event))
      XtDispatchEvent(&event);

    readspecs();
    slice = 0;
    sprintf(temp, "%sn.out", library);
    fp = fopen(temp, "r");
    readslice_readnums(fp);  /* read the raw bytes */
    fclose(fp);

    /* done reading; signal to simulator */
    write(sock, "x", 1);

    readslice_usenums(); /* translate strings to nums */

    /* need this, not Flush */
    XSync(display, False);
    while (XCheckMaskEvent(display, ExposureMask, &event))
      XtDispatchEvent(&event);

    readslice_checkscales(); /* stretch colorscales if needed */
    picture();  /* i *think* i need this here... try without */
    slices(slicelist);

    /* need this */
    XSync(display, False);

    sprintf(temp, "%s.%0*d.gif", library, ndig, n);
    dump_canvas(False, temp); 
  }
  /* all done! */

  movie_cleanup();

  /* clean up X stuff */
  XtDestroyWidget(toplevel);
  XtDestroyApplicationContext(app);
  XFlush(display);

  exit(0);
}
    

void movie_cleanup()
{
  char temp[1000];

  close(sock);

  /* lose the files the simulator left */
  sprintf(temp, "%sdat.out", library);
  unlink(temp);
  sprintf(temp, "%sn.out", library);
  unlink(temp);
  sprintf(temp, "%ss.out", library);
  unlink(temp);
}
