

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"


String paramhelp[][2] = {
  {"parameters window",
     "This window is used to display and alter some of the plot-relevant\n\
 parameters of the display.  Changing the values in the window will not\n\
alter the display until the changes are implemented with the <implement>\n\
toggle.  Any values that are altered by the program, i.e. when new data for\n\
some display field makes it necessary to stretch the scaled extrema values,\n\
the values in the window update automatically.\n"},
  
  {"<report>",
     "If this toggle is on when <implement> is pressed, invalid parameters\n\
will be reported (in the messenger popup) rather than changed.  If \n\
this toggle is off when <implement> is pressed, invalid parameters \n\
will be altered (typically reset or, if invalid because out of range, \n\
put at the end of the range).\n"},

  {"<implement>",
     "This implements all valid changes made to parameters.  Invalid \n\
parameters will be reported or altered depending on whether <report> \n\
is on.  If anything has a value in the window different from its \n\
current value, you will be asked to confirm implementation first.\n"},
  
  {"<reset>",
     "This resets the values in the window to their current values.  If \n\
anything has a value in the window different from its current value,\n\
you will be asked to confirm first.\n"},

  {"<save>",
     "This will prompt you for the name of a file and confirmation.  If a \n\
name is given and confirmed, the current values in the window will be\n\
saved to a file of that name.  They will be saved as '<label> <value>'\n\
(one to a line) where <label> is the name of the parameter (for \n\
instance, 'water depth boundary:  ') and <value> is the value in the \n\
window.  The resulting file will be a valid choice for loading or for\n\
running with the -p option.\n"},

{"<load>",
   "This will prompt you for the name of a file and confirmation.  If a \n\
name is given and confirmed, that file will be read and the values \n\
given by it for the parameters, according to the format described \n\
under <save>, placed in the parameter window; the changes are _not_ \n\
implemented by the load.  Any parameters whose names do not appear in\n\
the file, or whose names are not followed by numbers, will not be \n\
altered.  This is what happens at startup when the -p option is used.\n"},

{"<help>",
"You seem to have figured this one out already."},

{"<exit>",
   "If the values in the window are the current values, this will get rid\n\
of the window; otherwise it will produce a message to reset or \n\
implement changes.\n"},

{"skip lines",
   "When this is n, every nth timeline will be drawn.  It defaults to 1. \n\
It is useful in the frequent cases where you can't see the \n\
stratigraphy for the timelines.  \n"},

{"skip log nodes",
"When this is n, logs will be plotted on every nth node.\n\
It defaults to 10.\n"},

{"percent wheeler uses",
   "This is the percentage of the full height of the graph taken up by \n\
the Wheeler diagram of the oldest slice of the simulation.  \n\
It defaults to 50.\n"},

{"vertical exag",
   "Vertical spacial distances are multiplied by this value before being\n\
put in the picture.  It defaults to 100.  (Since the horizontal \n\
distances are of an order three orders of magnitude above that of the\n\
vertical distances, this is very necessary.)\n"},

{"vertical shift",
   "The entire picture will be shifted downwards by this length.  If it \n\
is nonzero, a dotted white line will appear at the effective new \n\
zero point.\n"},

{"xmin, xmax",
   "The positions (in meters) of the right and left sides of the visible\n\
area, defaulting to just cover the simulation.  If they are set to include\n\
space not covered by the simulation (i.e. xmin lower or xmax higher than\n\
default) --- probably to achieve horizontal compression --- the extra area\n\
will appear blank, as there is no data for it.\n"},

{"twtmin, twtmax",
   "The top and bottom of the visible area in Two-Way Time, in seconds,\n\
defaulting to [0, 1].  Used to stretch or compress the Twtime picture.\n"},

{"wavelet * ",
"The frequency and offset phase of the wavelet that describes the explosion\n\
for purposes of the seismic signal.\n\
\n\
Note that the offset phase is added to the dimensionless product of the time\n\
and frequency to be used as the argument of the signal function; since the\n\
signal functions are both zero outside [-1, 1] the phase is likely to be in\n\
that range.\n"},

{"water depth boundary",
   "A number between 0 and 1, which defines the proportion of the colorbar\n\
to be used to map the subaerial (nonmarine) deposition elevations.\n\
\n\
It defaults to .3; with this value the left 30% of the colorbar is devoted\n\
to subaerial deposition, the right 70% to subaqueous (marine) deposition,\n\
with zero water depth at the midpoint.\n\
\n\
It's a good idea to make this a multiple of .1, so that the zero point\n\
is explicitly labelled on the percentage bar.\n\
\n\
See the help entry for the water depth data for more information.\n"},

{"scales, powers, roots",
"See the \"data mapping\" entry in the main help menu (not this one)."},

{"velocities, densities",
"The velocities are of sound through the material.  Densities and sound\n\
velocities for fluid, sand, and shale are used in seismic calculations."},

{"exit help", "exit help"}};  /* this must be the last pair */
