

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"


/* Set up the structures associated with each user-modifiable parameter
   of the picture (rather than of the simulation); used to make the
   widgets in the paramstuff.c code. */


/* frankly, this system could use a lot of improvement.  it's a real pain
   to add a bunch of things! */


extern double vfluid, vsand, vshale;
extern double rhofluid, rhosand, rhoshale;
extern double nu, phi;


#define S param_func_return_string
static char S[100];

String facboundarycorrect(double x)
{
  if (x <= 1 && x >= 0) strcpy(S, "");
  else if (report) sprintf(S, "water depth boundary must be between 0 and 1");
  else sprintf(S, "%g", datascale[FACIES][0].boundary);
  
  return S;
}

Boolean facrel(void)  /* datascale[FACIES].boundary, .power[0], .power[1] */
{
  return (FACIES == data[wheeler] || (FACIES == logdata && !wheeler));
}

String facscale0correct(double x)
{
  if (x < datascale[FACIES][0].end[0][slice] && slice != -1)
    if (report) sprintf(S, "water depth scale aerial must be >= highest = %g", 
			datascale[FACIES][0].end[0][slice]);
    else sprintf(S, "%g", datascale[FACIES][0].end[0][slice]);
  else strcpy(S, "");

  return S;
}

Boolean facscalerel(void)   /* datascale[FACIES].low, .high */
{
  return ((FACIES == data[wheeler] && datascale[FACIES][0].scaled[0]) ||
	  (FACIES == logdata && !wheeler && datascale[FACIES][0].scaled[1]));
}

String facscale1correct(double x)
{
  if (x < datascale[FACIES][0].end[1][slice] && slice != -1)
    if (report) sprintf(S, "water depth scale aqueous must be >= deepest = %g", 
			datascale[FACIES][0].end[1][slice]);
    else sprintf(S, "%g", datascale[FACIES][0].end[1][slice]);
  else strcpy(S, "");

  return S;
}

String plotstepcorrect(double x)
{
  if (((int) x == x) && x > 0) strcpy(S, "");
  else if (report) sprintf(S, "skip lines # must be a positive integer");
  else sprintf(S, "%g", plotstep);
  
  return S;
}
Boolean plotsteprel(void)   
{  
  return (!wheeler && linesvis); 
}

String nodenumcorrect(double x)
{
  if (((int) x == x) && x > 0) strcpy(S, "");
  else if (report) sprintf(S, "skip log nodes # must be a positive integer");
  else sprintf(S, "%g", nodenum);

  return S;
}
Boolean nodenumrel(void)
{
  return (!wheeler && logdata != NODATA);
}

String porscale0correct(double x)
{
  if (compaction && x > datascale[POROSITY][0].end[0][slice] && slice != -1)
    if (report) sprintf(S, "porosity scale low must be <= min = %g", 
			datascale[POROSITY][0].end[0][slice]);
    else sprintf(S, "%g", datascale[POROSITY][0].end[0][slice]);
  else strcpy(S, "");

  return S;
}

Boolean porscalerel(void)
{
  return ((POROSITY == data[wheeler] && datascale[POROSITY][0].scaled[0]) ||
	  (POROSITY == logdata && !wheeler && datascale[POROSITY][0].scaled[1]));
}


String porscale1correct(double x)
{
  if (compaction && x < datascale[POROSITY][0].end[1][slice] && slice != -1)
    if (report) sprintf(S, "porosity scale high must be >= max = %g", 
			datascale[POROSITY][0].end[1][slice]);
    else sprintf(S, "%g", datascale[POROSITY][0].end[1][slice]);
  else strcpy(S, "");
  
  return S;
}

Boolean diffpowrel(void)
{
  return (DIFFUSION == data[wheeler] || (DIFFUSION == logdata && !wheeler));
}

String diffsclcorrect(double x)
{
  if (x < datascale[DIFFUSION][0].end[1][slice] && slice != -1)
    if (report) sprintf(S, "diffusion scale must be >= max diffusion = %g",
			datascale[DIFFUSION][0].end[1][slice]);
    else sprintf(S, "%g", datascale[DIFFUSION][0].end[1][slice]);
  else strcpy(S, "");

  return S;
}
Boolean diffsclrel(void)
{
  return ((DIFFUSION == data[wheeler] && datascale[DIFFUSION][0].scaled[0]) ||
	  (DIFFUSION == logdata && !wheeler &&datascale[DIFFUSION][0].scaled[1]));
}

String comscale0correct(double x)
{
  if (compaction && x > datascale[COMPOS][0].end[0][slice] && slice != -1)
    if (report) sprintf(S, "composition scale low must be <= min = %g", 
			datascale[COMPOS][0].end[0][slice]);
    else sprintf(S, "%g", datascale[COMPOS][0].end[0][slice]);
  else strcpy(S, "");

  return S;
}

Boolean comscalerel(void)
{
  return ((COMPOS == data[wheeler] && datascale[COMPOS][0].scaled[0]) ||
	  (COMPOS == logdata && !wheeler && datascale[COMPOS][0].scaled[1]));
}


String comscale1correct(double x)
{
  if (compaction && x < datascale[COMPOS][0].end[1][slice] && slice != -1)
    if (report) sprintf(S, "composition scale high must be >= max = %g", 
			datascale[COMPOS][0].end[1][slice]);
    else sprintf(S, "%g", datascale[COMPOS][0].end[1][slice]);
  else strcpy(S, "");

  return S;
}



String vexagcorrect(double x)
{
  if (x <= 0)
    if (report) sprintf(S, "vertical exag must be positive");
    else sprintf(S, "%g", vexag);
  else {
    strcpy(S, "");
    if (x != vexag) {
      ymax = ABOVE * (xmax - xmin) / x;
      ymin = (ABOVE - 1) * (xmax - xmin) / x;
    }
  }

  return S;
}

Boolean accumpowrel(void)
{
  return (ACCUM == data[wheeler] || (!wheeler && ACCUM == logdata));
}

String accumsclcorrect(double x)
{
  if (x < datascale[ACCUM][0].end[1][slice] && slice != -1)
    if (report) sprintf(S, "wheeler accum scale must be >= max accum = %g",
			datascale[ACCUM][0].end[1][slice]);
    else sprintf(S, "%g", datascale[ACCUM][0].end[1][slice]);
  else strcpy(S, "");

  return S;
}
Boolean accumsclrel(void)
{
  return ((ACCUM == data[wheeler] && datascale[ACCUM][0].scaled[0]) ||
	  (ACCUM == logdata && !wheeler && datascale[ACCUM][0].scaled[1]));
}

Boolean maxaccumpowrel(void)
{
  return (MAXACCUM == data[wheeler] || (MAXACCUM == logdata && !wheeler));
}

String maxaccumsclcorrect(double x)
{
  if (x < datascale[MAXACCUM][0].end[1][slice] && slice != -1)
    if (report) sprintf(S, "wlr maxaccum scale must be >= max max accum = %g",
			datascale[MAXACCUM][0].end[1][slice]);
    else sprintf(S, "%g", datascale[MAXACCUM][0].end[1][slice]);
  else strcpy(S, "");

  return S;
}
Boolean maxaccumsclrel(void)
{
  return ((MAXACCUM == data[wheeler] && datascale[MAXACCUM][0].scaled[0]) ||
	  (MAXACCUM == logdata && !wheeler && datascale[MAXACCUM][0].scaled[1]));
}

String velocityscale0correct(double x)
{
  if (x > datascale[VELOCITY][0].end[0][slice] && slice != -1)
    if (report) sprintf(S, "velocity scale low must be <= min = %g",
			datascale[VELOCITY][0].end[0][slice]);
    else sprintf(S, "%g", datascale[VELOCITY][0].end[0][slice]);
  else strcpy(S, "");

  return S;
}
String velocityscale1correct(double x)
{
  if (x < datascale[VELOCITY][0].end[1][slice] && slice != -1)
    if (report) sprintf(S, "velocity scale high must be >= max = %g",
			datascale[VELOCITY][0].end[1][slice]);
    else sprintf(S, "%g", datascale[VELOCITY][0].end[1][slice]);
  else strcpy(S, "");

  return S;
}
Boolean velocityscalerel(void)
{
  return ((VELOCITY == data[wheeler] && datascale[VELOCITY][0].scaled[0]) ||
	  (VELOCITY == logdata && !wheeler 
	   && datascale[VELOCITY][0].scaled[1]));
}

String densityscale0correct(double x)
{
  if (x > datascale[DENSITY][0].end[0][slice] && slice != -1)
    if (report) sprintf(S, "density scale low must be <= min = %g",
			datascale[DENSITY][0].end[0][slice]);
    else sprintf(S, "%g", datascale[DENSITY][0].end[0][slice]);
  else strcpy(S, "");

  return S;
}
String densityscale1correct(double x)
{
  if (x < datascale[DENSITY][0].end[1][slice] && slice != -1)
    if (report) sprintf(S, "density scale high must be >= max = %g",
			datascale[DENSITY][0].end[1][slice]);
    else sprintf(S, "%g", datascale[DENSITY][0].end[1][slice]);
  else strcpy(S, "");

  return S;
}
Boolean densityscalerel(void)
{
  return ((DENSITY == data[wheeler] && datascale[DENSITY][0].scaled[0]) ||
	  (DENSITY == logdata && !wheeler && datascale[DENSITY][0].scaled[1]));
}

String impedscale0correct(double x)
{
  if (x > datascale[IMPED][0].end[0][slice] && slice != -1)
    if (report) sprintf(S, "impedance scale low must be <= min = %g",
			datascale[IMPED][0].end[0][slice]);
    else sprintf(S, "%g", datascale[IMPED][0].end[0][slice]);
  else strcpy(S, "");

  return S;
}
String impedscale1correct(double x)
{
  if (x < datascale[IMPED][0].end[1][slice] && slice != -1)
    if (report) sprintf(S, "impedance scale high must be >= max = %g",
			datascale[IMPED][0].end[1][slice]);
    else sprintf(S, "%g", datascale[IMPED][0].end[1][slice]);
  else strcpy(S, "");

  return S;
}
Boolean impedscalerel(void)
{
  return ((IMPED == data[wheeler] && datascale[IMPED][0].scaled[0]) ||
	  (IMPED == logdata && !wheeler && datascale[IMPED][0].scaled[1]));
}

String condscale0correct(double x)
{
  if (x > datascale[CONDUCT][0].end[0][slice] && slice != -1)
    if (report) sprintf(S, "heat cond. scale low must be <= min = %g",
			datascale[CONDUCT][0].end[0][slice]);
    else sprintf(S, "%g", datascale[CONDUCT][0].end[0][slice]);
  else strcpy(S, "");

  return S;
}
String condscale1correct(double x)
{
  if (x < datascale[CONDUCT][0].end[1][slice] && slice != -1)
    if (report) sprintf(S, "heat cond. scale high must be >= max = %g",
			datascale[CONDUCT][0].end[1][slice]);
    else sprintf(S, "%g", datascale[CONDUCT][0].end[1][slice]);
  else strcpy(S, "");

  return S;
}
Boolean condscalerel(void)
{
  return ((CONDUCT == data[wheeler] && datascale[CONDUCT][0].scaled[0]) ||
	  (CONDUCT == logdata && !wheeler && datascale[CONDUCT][0].scaled[1]));
}

String thermscale0correct(double x)
{
  if (x > datascale[THERM][0].end[0][slice] && slice != -1)
    if (report) sprintf(S, "temperature scale low must be <= min = %g",
			datascale[THERM][0].end[0][slice]);
    else sprintf(S, "%g", datascale[THERM][0].end[0][slice]);
  else strcpy(S, "");

  return S;
}
String thermscale1correct(double x)
{
  if (x < datascale[THERM][0].end[1][slice] && slice != -1)
    if (report) sprintf(S, "temperature scale high must be >= max = %g",
			datascale[THERM][0].end[1][slice]);
    else sprintf(S, "%g", datascale[THERM][0].end[1][slice]);
  else strcpy(S, "");

  return S;
}
Boolean thermscalerel(void)
{
  return ((THERM == data[wheeler] && datascale[THERM][0].scaled[0]) ||
	  (THERM == logdata && !wheeler && datascale[THERM][0].scaled[1]));
}

String thgradscale0correct(double x)
{
  if (x > datascale[THGRAD][0].end[0][slice] && slice != -1)
    if (report) sprintf(S, "temp. grad. scale low must be <= min = %g",
			datascale[THGRAD][0].end[0][slice]);
    else sprintf(S, "%g", datascale[THGRAD][0].end[0][slice]);
  else strcpy(S, "");

  return S;
}
String thgradscale1correct(double x)
{
  if (x < datascale[THGRAD][0].end[1][slice] && slice != -1)
    if (report) sprintf(S, "temp. grad. scale high must be >= max = %g",
			datascale[THGRAD][0].end[1][slice]);
    else sprintf(S, "%g", datascale[THGRAD][0].end[1][slice]);
  else strcpy(S, "");

  return S;
}
Boolean thgradscalerel(void)
{
  return ((THGRAD == data[wheeler] && datascale[THGRAD][0].scaled[0]) ||
	  (THGRAD == logdata && !wheeler && datascale[THGRAD][0].scaled[1]));
}

String ttiscale0correct(double x)
{
  if (x > datascale[TTI][0].end[0][slice] && slice != -1)
    if (report) sprintf(S, "sum TTI scale low must be <= min = %g",
			datascale[TTI][0].end[0][slice]);
    else sprintf(S, "%g", datascale[TTI][0].end[0][slice]);
  else strcpy(S, "");

  return S;
}
String ttiscale1correct(double x)
{
  if (x < datascale[TTI][0].end[1][slice] && slice != -1)
    if (report) sprintf(S, "sum TTI scale high must be >= max = %g",
			datascale[TTI][0].end[1][slice]);
    else sprintf(S, "%g", datascale[TTI][0].end[1][slice]);
  else strcpy(S, "");

  return S;
}
Boolean ttiscalerel(void)
{
  return ((TTI == data[wheeler] && datascale[TTI][0].scaled[0]) ||
	  (TTI == logdata && !wheeler && datascale[TTI][0].scaled[1]));
}

String sigscalecorrect(double x)
{
  if (x < datascale[SIGNAL][0].end[0][slice] && slice != -1)
    if (report) sprintf(S, "signal scale must be >= max = %g",
			datascale[SIGNAL][0].end[0][slice]);
    else sprintf(S, "%g", datascale[SIGNAL][0].end[0][slice]);
  else strcpy(S, "");

  return S;
}
Boolean sigscalerel(void)
{
  return ((SIGNAL == data[wheeler] && datascale[SIGNAL][0].scaled[0]) ||
	  (SIGNAL == logdata && !wheeler && datascale[SIGNAL][0].scaled[1]));
}
Boolean sigpowrel(void)
{
  return (SIGNAL == data[wheeler] || (SIGNAL == logdata && !wheeler));
}

String wheelerusecorrect(double x)
{
  if (x > 0 && x <= 100) strcpy(S, "");
  else if (report) sprintf(S, "%% wheeler uses must be between 0 and 100");
  else sprintf(S, "%g", wheeleruse);

  return S;
}
Boolean wheeleruserel(void)
{
  return wheeler;
}

Boolean nonwheelerrel(void)
{
  return !wheeler;
}

String xmaxcorrect(double x)
{
  if (x <= xmin)
    if (report) sprintf(S, "xmax must be > xmin = %g", xmin);
    else sprintf(S, "%g", xmax);
  else {
    strcpy(S, "");
    if (x != xmax) {
      ymax = ABOVE * (x - xmin) / vexag;
      ymin = (ABOVE - 1) * (x - xmin) / vexag;
    }
  }

  return S;
}

String xmincorrect(double x)
{
  if (x >= xmax)
    if (report) sprintf(S, "xmin must be < xmax = %g", xmax);
    else sprintf(S, "%g", xmin);
  else {
    strcpy(S, "");
    if (x != xmin) {
      ymax = ABOVE * (xmax - x) / vexag;
      ymin = (ABOVE - 1) * (xmax - x) / vexag;
    }
  }
  
  return S;
}

Boolean twtrel(void)
{
  return (TWTIME == axismode);
}

String vfluidcorrect(double x)
{
  if (x > 0) strcpy(S, "");
  else
    if (report) sprintf(S, "velocity in fluid must be positive");
    else sprintf(S, "%g", vfluid);
  
  return S;
}

String vsandcorrect(double x)
{
  if (x > 0) strcpy(S, "");
  else
    if (report) sprintf(S, "velocity in sand must be positive");
    else sprintf(S, "%g", vsand);
  
  return S;
}

String vshalecorrect(double x)
{
  if (x > 0) strcpy(S, "");
  else
    if (report) sprintf(S, "velocity in shale must be positive");
    else sprintf(S, "%g", vshale);
  
  return S;
}

Boolean velocityrel(void)
{
  if (wheeler) return False;

  if (TWTIME == axismode) return True;

  if (VELOCITY == data[wheeler]) return True;
  if (IMPED == data[wheeler]) return True;
  if (SIGNAL == data[wheeler]) return True;
    
  if (VELOCITY == logdata) return True;
  if (IMPED == logdata) return True;
  if (SIGNAL == logdata) return True;
  
  if (reflecmode) return True;

  return False;
}

String rhofluidcorrect(double x)
{
  if (x > 0) strcpy(S, "");
  else
    if (report) sprintf(S, "density of fluid must be positive");
    else sprintf(S, "%g", rhofluid);
  
  return S;
}

String rhosandcorrect(double x)
{
  if (x > 0) strcpy(S, "");
  else
    if (report) sprintf(S, "density of sand must be positive");
    else sprintf(S, "%g", rhosand);
  
  return S;
}

String rhoshalecorrect(double x)
{
  if (x > 0) strcpy(S, "");
  else
    if (report) sprintf(S, "density of shale must be positive");
    else sprintf(S, "%g", rhoshale);
  
  return S;
}

Boolean densityrel(void)
{
  if (wheeler) return False;

  if (TWTIME == axismode) return True;

  if (DENSITY == data[wheeler]) return True;
  if (IMPED == data[wheeler]) return True;
  if (SIGNAL == data[wheeler]) return True;
    
  if (DENSITY == logdata) return True;
  if (IMPED == logdata) return True;
  if (SIGNAL == logdata) return True;
  
  if (reflecmode) return True;

  return False;
}

String frequencycorrect(double x)
{
  if (x > 0) strcpy(S, "");
  else if (report) sprintf(S, "frequency must be positive");
  else sprintf(S, "%g", nu);

  return S;
}

Boolean waveletrel(void)
{
  if (wheeler) return False;

  if (SIGNAL == data[wheeler]) return True;
  if (SIGNAL == logdata) return True;

  return False;
}


#undef S


String alwayscorrect(double x)  { return ""; }
Boolean alwaysrel(void)  { return True; }


typedef String correctfunc();
typedef Boolean relevantfunc();

struct {
  String name;                 /* don't put %s in the name */
  double *var;
  correctfunc *correct;
  relevantfunc *relevant;
  int havedataindex;
  Widget dialog, val;
} param[] = { 
  {"skip lines:  ", &plotstep, plotstepcorrect, plotsteprel},
  {"skip log nodes:  ", &nodenum, nodenumcorrect, nodenumrel},
  {"percent wheeler uses:  ", &wheeleruse, wheelerusecorrect, wheeleruserel},
  {"vertical exag:  ", &vexag, vexagcorrect, nonwheelerrel},
  {"vertical shift:  ", &yshift, alwayscorrect, nonwheelerrel},
  {"xmax:  ", &xmax, xmaxcorrect, alwaysrel},
  {"xmin:  ", &xmin, xmincorrect, alwaysrel},
  {"twtmax:  ", &twtmax, alwayscorrect, twtrel},
  {"twtmin:  ", &twtmin, alwayscorrect, twtrel},
  {"wavelet frequency:  ", &nu, frequencycorrect, waveletrel},
  {"wavelet offset phase:  ", &phi, alwayscorrect, waveletrel},
  {"water depth boundary:", &datascale[FACIES][0].boundary, facboundarycorrect,
   facrel},
  {"subaerial water depth power:  ", &datascale[FACIES][0].power[0], 
     alwayscorrect, facrel},
  {"subaqueous water depth power:  ", &datascale[FACIES][0].power[1], 
     alwayscorrect, facrel},
  {"water depth scale aerial:  ", &datascale[FACIES][0].use[0], 
   facscale0correct, facscalerel},
  {"water depth scale aqueous:  ", &datascale[FACIES][0].use[1], 
   facscale1correct, facscalerel},
  {"diffusion power:  ", &datascale[DIFFUSION][0].power[0], alwayscorrect, 
     diffpowrel},
  {"diffusion scale:  ", &datascale[DIFFUSION][0].use[1], diffsclcorrect, 
     diffsclrel},
  {"composition scale low:  ", &datascale[COMPOS][0].use[0], comscale0correct,
     comscalerel},
  {"composition scale high:  ", &datascale[COMPOS][0].use[1], comscale1correct,
     comscalerel},
  {"wheeler accum root:  ", &datascale[ACCUM][0].power[0], alwayscorrect, 
     accumpowrel},
  {"wheeler accum scale:  ", &datascale[ACCUM][0].use[1], accumsclcorrect, 
     accumsclrel},
  {"wheeler maxaccum root:  ", &datascale[MAXACCUM][0].power[0], alwayscorrect,
     maxaccumpowrel},
  {"wheeler maxaccum scale:  ", &datascale[MAXACCUM][0].use[1],
   maxaccumsclcorrect, maxaccumsclrel},
  {"velocity in fluid:  ", &vfluid, vfluidcorrect, velocityrel},
  {"velocity in sand:  ", &vsand, vsandcorrect, velocityrel},  
  {"velocity in shale:  ", &vshale, vshalecorrect, velocityrel},
  {"velocity scale low:  ", &datascale[VELOCITY][0].use[0], 
   velocityscale0correct, velocityscalerel},
  {"velocity scale high:  ", &datascale[VELOCITY][0].use[1],
   velocityscale1correct, velocityscalerel},
  {"density of fluid:  ", &rhofluid, rhofluidcorrect, densityrel},
  {"density of sand:  ", &rhosand, rhosandcorrect, densityrel},
  {"density of shale:  ", &rhoshale, rhoshalecorrect, densityrel}, 
  {"density scale low:  ", &datascale[DENSITY][0].use[0], densityscale0correct,
     densityscalerel},
  {"density scale high:  ", &datascale[DENSITY][0].use[1], 
   densityscale1correct, densityscalerel},
  {"impedance scale low:  ", &datascale[IMPED][0].use[0], impedscale0correct,
     impedscalerel},
  {"impedance scale high:  ", &datascale[IMPED][0].use[1], impedscale1correct,
     impedscalerel},
  {"signal scale:  ", &datascale[SIGNAL][0].use[0], sigscalecorrect, 
   sigscalerel},
  {"signal root:  ", &datascale[SIGNAL][0].power[0], alwayscorrect, sigpowrel},
  {"porosity scale low:  ", &datascale[POROSITY][0].use[0], porscale0correct,
     porscalerel, 1},
  {"porosity scale high:  ", &datascale[POROSITY][0].use[1], porscale1correct,
     porscalerel, 1},
  {"heat cond. low:  ", &datascale[CONDUCT][0].use[0], condscale0correct,
     condscalerel, 5},
  {"heat cond. high:  ", &datascale[CONDUCT][0].use[1], condscale1correct,
    condscalerel, 5}, 
  {"temperature low:  ", &datascale[THERM][0].use[0], thermscale0correct,
     thermscalerel, 5},
  {"temperature high:  ", &datascale[THERM][0].use[1], thermscale1correct,
     thermscalerel, 5},
  {"temp. grad. low:  ", &datascale[THGRAD][0].use[0], thgradscale0correct,
     thgradscalerel, 5},
  {"temp. grad. high:  ", &datascale[THGRAD][0].use[1], thgradscale1correct,
     thgradscalerel, 5},
  {"sum TTI low:  ", &datascale[TTI][0].use[0], ttiscale0correct, ttiscalerel, 
   6},
  {"sum TTI high:  ", &datascale[TTI][0].use[1], ttiscale1correct, ttiscalerel,
   6} };
