

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"



String plothelp[][2] = {
  {"general",
     "This program is used to view the output of the basin simulator \n\
program.  It uses the simulator's outputs --- <library>dat.out,\n\
<library>s.out, and <library>1.out thru <library>6.out (actually, it\n\
only reads the nth one when you select the nth age, so in theory you\n\
don't need them all there, but you should --- besides, the simulator\n\
makes them all, so there's no reason not to have them).\n\
\n\
To run, type 'plotbasin <library name> [options].'  Eg:  if you want\n\
to use a library named 'runex' that is in the directory above your \n\
current directory, type 'plotbasin ../runex' to run.   'plotbasin' \n\
will give you the command syntax, 'plotbasin help' will give you a \n\
command summary.  Using 'plotbasin ../runex' requires the files \n\
../runexdat.out, ../runexs.out, ../runex1.out, etc, to be there (they\n\
should be the output of the simulator).\n\
\n\
Options:  the currently supported option is -p, used to declare \n\
parameter files to load at startup, as in\n\
          plotbasin <library> -p my.nice.parameters my.other.parameters\n\
\n\
All parameters have default values hardwired into the program.  These\n\
may be changed in the parameters window, accessed via the \n\
'parameters' button.  The window allows saving and loading of \n\
parameters.  Invoking plotbasin with -p file1 file2... reads \n\
parameter values from file1, then file2, etc, and uses them to \n\
override the default values.  Later values override earlier ones, \n\
both within a file and among files.  Entries of the format \n\
<parameter name> <parameter value> will be accepted, where \n\
<parameter name> is _exactly_ the string displayed in the parameter \n\
window for that parameter, including ':'s etc, and <parameter value>\n\
is a real number.  All other lines in parameter files will be \n\
ignored.  Parameter files which do not exist will be ignored.  The \n\
best way to make a parameter file is to use the 'save' button on the \n\
parameter window and edit the resulting file with your favorite text \n\
editor if desired.  Any parameters not overridden by such parameter \n\
files will remain at the default values.  All this only applies to \n\
the parameters found in the parameter window; these can all be \n\
changed while running regardless of how the initial values are \n\
obtained. Parameter files can also be read in with the parameter \n\
window's 'load' button.\n"},
  

  {"license",
     "Plotbasin and the rest of the Strata suite have been put under the Gnu\n\
General Public License, of which you should have copies both in the Strata\n\
user manual and the source code of each program.  This license includes the\n\
following notice:\n\
\n\
                           NO WARRANTY\n\
\n\
BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE\n\
PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN OTHERWISE\n\
STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE\n\
PROGRAM 'AS IS' WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,\n\
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND\n\
FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND\n\
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE,\n\
YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.\n\
\n\
IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL\n\
ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR REDISTRIBUTE\n\
THE PROGRAM AS PERMITTED [elsewhere in the License], BE LIABLE TO YOU FOR\n\
DAMAGED, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES\n\
ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT\n\
LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED\n\
BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER\n\
PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE\n\
POSSIBILITY OF SUCH DAMAGES.\n\
\n\
\n\
The license also specifies exact terms for the modification and/or\n\
redistribution of the code; please refer to it for details on this and other\n\
such matters.\n"},
  
  {"false colors",
     "When the mouse pointer has activated a window other than the \n\
plotter's, the plotter may appear in false colors, and vice versa.  \n\
Also, if you run another graphics application odd things can happen \n\
to the colors --- for instance, starting up xv.  Refreshing/redrawing\n\
the plot window should take care of these.\n"},
  
  {"ages",
     "The numbers in the horizontal row just above the buttons and just \n\
below everything else are the ages of the timeslices saved by the simulator.\n\
Click on an age to load that slice.\n\
\n\
Loading can take some time the first time a slice is examined.\n"},
  
  {"displays",
     "The plotter window has several information displays. \n\
\n\
The title of the window indicates the library being used.\n\
\n\
In the upper left-hand corner is a box with a rectangle above it.\n\
When the vertical axis is Depth, the box has three colored lines in it\n\
and the rectangle has three angles in degrees.  Each line shows how a line\n\
at the angle of the same color appears in the window.  Lines of .1 degrees,\n\
1 degree, and 10 degrees are displayed.\n\
When the vertical axis is Two-Way Time, the boxes are empty, unless the \n\
reflection coefficients and/or seismic signal are visible, in which case\n\
the larger box contains a sample wavelet of the currently-specified function\n\
around a reflection coefficient bar of strength 10%.  The shape of the\n\
wavelet is meaningful; the vertical scale of the wavelet is meaningful;\n\
the length of the reflection coefficient is meaningful; the amplitude \n\
(horizontal scale) of the wavelet is NOT meaningful, being a constant meant\n\
to show up nicely in the box.\n\
In Wheeler mode the boxes are empty.\n\
\n\
On the left side of the plotter is a box with two bars of different \n\
shades of gray, each with a label beneath.  These are scalebars for \n\
vertical distances.  They show, to scale, two appropriate vertical lengths.\n\
The smaller is one-tenth the length of the longer, which is ticked into tenths.\n\
On the upper side of the plotter, just above the graph box and just \n\
below the colorbar, is a similar box for two horizontal scalebars, which\n\
act similarly for horizontal lengths.  Note that the horizontal scalebars\n\
may be in different units; they'll be marked.\n\
\n\
The box with the horizontal scalebars is also used to display (at the left)\n\
information on data units and values when certain data sets are displayed.\n\
\n\
Just above the horizontal scalebar is a colorbar.  When you plot data\n\
that is displayed in color, this bar will display the spectrum being \n\
used.  (If you resize the plot window, you'll probably chop off part \n\
of the spectrum, or get black at the end; next time the picture is \n\
redrawn the colorbar will be fixed.)  The colorbar has vertical black\n\
lines in it every 10% of the way.  These correspond to the \n\
percentages displayed in the percentage bar just above.\n\
\n\
Just above the colorbar is a percentage bar.  It shows what \n\
percentage (of whatever quantity is appropriate) the color at the \n\
point indicated by the neighboring black line in the colorbar \n\
represents.  There is likely to be a note in the right side of the\n\
horizontal scalebar with a note as to the color data's units.\n\
\n\
In the bottom left-hand corner there is a white space.  When the \n\
program is doing something time-consuming, such as reading in a \n\
previously unselected slice, coloring in a color data set, or \n\
plotting timelines, a label will appear there saying what it is \n\
doing, and a horizontal bar will grow underneath to indicate how much\n\
of the task is done.\n"}, 

  {"<fill>",
     "The data selected in this menu, if it is not left empty, will be used\n\
to fill in the areas defined by the spacial nodes, horizontally, and the\n\
timelines, vertically (in Wheeler mode, the vertical axis is just time).\n\
See each data type's entry for explanations of what they are.  Note that\n\
Wheeler and nonWheeler modes have distinct data fields available.\n\
\n\
See the \"data mapping\" entry for information on data-to-color mapping."},

  {"<log>",
     "The data selected in this menu, if not left empty, is drawn as a\n\
log.  This is not possible in Wheeler mode.  See the <misc> menu entry\n\
on logs for a description of the drawing.  The baseline is the minimum\n\
data value (or scaled minimum).  'Skip log nodes' in the parameter window\n\
controls the node sampling.\n\
\n\
See the \"data mapping\" entry for information on data-to-color mapping."},

  {"<scale>",
     "The <scale> toggles attached to the <fill> and <log> buttons control\n\
whether to scale the fill and log data.  They are independent, and scaling\n\
for each data field is independent and remembered seperately by the toggles.\n\
If scaling is on, the artificial extrema defined for that data field in the\n\
parameters window are used instead of the actual extrema for purposes of\n\
amplitudes (log) and color mappings (fill).  \n\
\n\
Symbolically, the data value x is mapped to \n\
\n\
      (x   - x_0)\n\
      ---------\n\
      (x_1 - x_0)\n\
\n\
where (x_0, x_1) = (x_min, x_max) if scaling is off,\n\
and              = (x_low, x_high) if scaling is on.\n\
\n\
Note that the 'power' entries\n\
in the parameters window always apply to fill data, and never apply to log\n\
data, regardless of scaling.  There is no scaling (nor power adjustment) for\n\
contour data.\n\
\n\
Since the scaled range must include the actual range, scaling cannot be\n\
used to 'zoom in' on a portion of the data.  The purpose of scaling is to\n\
allow meaningful comparisons in color of displays of two different slices\n\
of the simulation, or of different simulations.  By putting both on the same\n\
scale, which includes each data set, you can ensure that the meanings of any\n\
given color shade are identical.\n\
\n\
Also see the \"data mapping\" entry."},

{"data mapping",
   "Data in various displays are frequently altered before display, either\n\
to emphasize portions of the data spectrum or to match colors with other\n\
displays.  <fill> data are subject to both scales and powers/roots; <log>\n\
data are subject to scales only; <contour> data is unaffected by both.\n\
\n\
Data values are always first mapped onto the range [0, 1].\n\
Symbolically, the data value x is mapped to \n\
\n\
      (x   - x_0)\n\
      ---------\n\
      (x_1 - x_0)\n\
\n\
where (x_0, x_1) = (x_min, x_max) if scaling is off,\n\
and              = (x_low, x_high) if scaling is on.\n\
\n\
Since the scaled range must include the actual range, scaling cannot be\n\
used to 'zoom in' on a portion of the data.  The purpose of scaling is to\n\
allow meaningful comparisons in color of displays of two different slices\n\
of the simulation, or of different simulations.  By putting both on the same\n\
scale, which includes each data set, you can ensure that the meanings of any\n\
given color shade are identical.\n\
\n\
Certain data types are then taken to a power or root, thus mapping the range\n\
[0, 1] onto itself, but with one end or the other emphasized.  This is only\n\
done for certain types of <fill> data.\n\
\n\
Symbolically, after a data value x is mapped onto some value z in the\n\
range [0, 1], as described under above, it is mapped to z^power or z^(1/root)\n\
before being mapped onto the colorbar (typically with zero at the left and\n\
one at the right).\n\
\n\
The diffusion power defaults to 1.\n\
\n\
The water depth powers default to 1; note that subaerial and subaqueous\n\
depths are mapped seperately.\n\
\n\
The roots for (Wheeler) accumulation and max accumulation default to 2.\n\
\n\
The root for signal defaults to 1 (note that positive and negative values\n\
are mapped symmetrically).\n\
\n\
Other data types are not taken to any power nor root."},

  {"log amplitude",
     "The number box attached to the <log> button controls the amplitude of\n\
the log display of the appropriate datum.  The log amplitudes for various\n\
data are independent.  The right, left, and middle buttons of the mouse\n\
increment, decrement, and return the amplitude to the default, respectively.\n\
If, having adjusted the log amplitude, you wish to redraw the picture\n\
without changing anything else, you may do so by reselecting your choice in\n\
the <log> menu --- this would do nothing in the <fill> and <contour> menus,\n\
but causes a redraw in the <log> menu specifically for this purpose.\n"},

  {"<contour>",
     "The data selected in this menu, if not left empty, is used to\n\
construct a contour plot.  The smallest contour is plotted with a dotted\n\
line to distinguish it, and its value is given in the right side of\n\
the horizontal scalebar area.  The box attached to the <contour> button is\n\
to be used to specify the contour level of each (independent) data field.\n\
It defaults to one-tenth the difference between the maximum and minumum\n\
values of that data field present in the slice as of the last calculation.\n\
Change it by typing into that box; hit <return> to implement the new value\n\
(and redraw the picture)."},

  {"water depth",
     "When this data is selected for fill or log water depth information is\n\
displayed.  For fill, you get a color plot; the trapezoidal area between \n\
four points (two succeeding points of a timeline, and the two equivalent\n\
points of the next timeline) is colored in according to the average of the\n\
values at the four points.\n\
\n\
See the \"data mapping\" entry about the data-to-color mapping; subaerial and\n\
subaqueous values go through the process described therein seperately.\n\
Following it, the subaerial values are mapped from [0, 1] onto [border, 0],\n\
and subaqueous values from [0, 1] to [border, 1], linearly.\n\
That is, with the border between subaerial and subaqueous at .3 (the default;\n\
this can be changed in the parameters window), the range [0, h], with h as\n\
the highest (maximally subaerial) value, gets scaled/powered to [0, 1], with\n\
0 going to 0 and h to 1, and then sent linearly to [0, .3] such that the \n\
original h ends up at 0 and the original 0 at .3 (i.e. the range is flipped).\n\
The range [0, d], with d the deepest (maximally subaqueous) value, gets\n\
scaled/powered to [0, 1] and then sent linearly to [.3, 1], such that\n\
0 ends up at .3 and d at 1.  Thus the trio of points (h, 0, d) is sent to\n\
(0, border, 1) in all cases."},
  
  {"porosity",
"The trapezoidal area between four points (two succeeding points of a \n\
timeline, and the two equivalent points of the next timeline) is \n\
colored in according to the average of the porosity values at the \n\
four points.\n\
\n\
See the \"data mapping\" help entry for information about scales."},

  {"diffusion",
"A type of fill/log/contour data; the prevailing diffusion constant at each\n\
point.\n\
\n\
Also see the \"data mapping\" help entry,"},

  {"composition",
"The calculation of composition at a point depends on what the simulator \n\
used, which depends on what the user fed it.  If diffusion was the \n\
determining factor, then sand and shale are considered to be linearly \n\
distributed by diffusion constant between nonmarine and marine constants.\n\
This is indicated by a (D) note.\n\
\n\
If water depth was the determining factor, then there is some cutoff depth\n\
such that rock deposited at depths less than it is all sand, and deposits at\n\
greater depths become shale exponentially according to some decay constant \n\
--- the constants being specified to the simulator by the user in the \n\
library and passed to the plotter by the simulator.  This is indicated\n\
by a (W) note.\n\
\n\
Also see the \"data mapping\" help entry."},

  {"velocity", 
     "A type of fill/log/contour data; the velocity of sound through the\n\
medium at each point.  The velocities through sand, shale, and water are\n\
each specified in the parameters window.  The sand/shale composition at each\n\
point is determined either by water depth or by diffusion constant, as\n\
explained under 'composition.'  The porosity is the same as the porosity\n\
data field.  The velocity at each point is then calculated with\n\
\n\
     1 / v = porosity / v_fluid  + (1 - porosity) / v_solid   \n\
\n\
where\n\
\n\
     v_solid = v_sand * %sand + v_shale * %shale.\n\
\n\
\n\
The velocity field determines the mapping between depth and two-way time.\n\
\n\
Typical v in sand, shale, and water are 5487, 4545, and 1604 m/s respectively.\n\
\n\
Also see the \"data mapping\" help entry."},

  {"density",
     "A type of fill/log/contour data; the density of the material at each \n\
point.  The densities of sand, shale, and water are specified in the \n\
parameters window.  The sand/shale composition at each point is determined\n\
as explained under 'composition.'  The porosity is the same as the porosity\n\
data field.  The density at each point is then calculated as\n\
\n\
     rho = porosity * rho_fluid + (1 - porosity) * rho_solid\n\
\n\
where\n\
\n\
     rho_solid = rho_sand * %sand + rho_shale * %shale.\n\
\n\
Typical rho for sand, shale, and water are 2650, 2500, and 1000 kg/m^3 resp.\n\
\n\
Also see the \"data mapping\" help entry."},

  {"impedance",
     "A type of fill/log/contour data; the impedance of the material to\n\
sound waves at each point.  The velocity of sound and the density at each \n\
point are determined as explained under 'velocity' and 'density,' and the\n\
impedance is their product.  Sharp gradients in the impedance field produce\n\
seismic signals as explained under 'signal.'\n\
\n\
Also see the \"data mapping\" help entry."},

  {"signal", 
     "The impedance field (see 'impedance') is used to calculate reflection\n\
coefficients for downward-propagating sound waves at each spacial node at\n\
each timeline of the basin.  The reflection coefficients are determined as\n\
\n\
   (impedance_above - impedance_below) / (impedance_above + impedance_below)\n\
\n\
including sign.  There is an entry in the <misc> menu which allows these\n\
coefficients to be viewed directly.\n\
There is assumed to be a series of simultaneous explosions at all points on\n\
the surface (at sealevel for those points which are underwater).  The energy\n\
in these is propagated vertically only, reflecting at each sharp impedance\n\
gradient.  Only primary reflections are considered; second-order effects\n\
are ignored; energy loss is neglible.\n\
Thus the received signal at the surface is simply the convolution of the \n\
initial explosion wavelet with the reflection coefficients.\n\
\n\
The form of the wavelet is specified in the <misc> menu.  The options, \n\
as functions of the dimensionless quantity u = (time * frequency), are:\n\
\n\
     ricker displacement:  N * u * exp(- u^2 / 4), \n\
or\n\
     ricker velocity:      N * (1 - u^2 / 2) * exp(- u^2 / 4),\n\
\n\
where N = (4 * square root of pi) is a normalization constant. \n\
\n\
The frequency, and offset phase if desired (default 0), are specified in the\n\
parameters window.  Typical frequencies are 10 to 100 Hz; they may go beyond.\n\
\n\
The form of the log signal display can be altered in the <misc> menu.\n\
(There is no contour display of signal; it'd be silly.)\n\
\n\
Also see the \"data mapping\" help entry."},

{"heat cond.",
"A type of fill/log/contour data; the thermal conductivity at each point, as\n\
determined from the composition field, the porosity field, and the heat\n\
conductivities of sand, shale, and fluid as passed by the simulator, thus:\n\
\n\
     cond = porosity * cond_fluid + (1 - porosity) * cond_solid\n\
\n\
where\n\
\n\
     cond_solid = cond_sand * %sand + cond_shale * %shale.\n\
\n\
This data is only available if the simulator performed thermal calculations\n\
and will not be offered otherwise.\n\
\n\
Also see the \"data mapping\" help entry."},

{"temperature",
"A type of fill/log/contour data; the temperature at each point, as passed\n\
by the simulator (if it performed thermal calculations).\n\
\n\
Also see the \"data mapping\" help entry."},

{"temp. grad.",
"A type of fill/log/contour data; the vertical temperature gradient at each\n\
point, as determined from the temperature field.  Only available if the \n\
simulator performed thermal calculations.  The sign is taken to be positive\n\
for downward-increasing temperatures.\n\
\n\
Also see the \"data mapping\" help entry."},

{"sum TTI",
"A type of fill/log/contour data; the Sum Time-Temperature Index at each\n\
point, as calculated by the simulator (if it did thermal calculations).  It\n\
is the time integral of 2 to the power of ((temperature - 100) / 10), where\n\
the temperature is in Centigrade, and is given in the standard units of\n\
megayears.\n\
\n\
Also see the \"data mapping\" help entry."},

{"isotopes",
   "If the simulation included one or more isotope signals, they will be\n\
available as fill/log (but not contour) data.  Their names will be whatever\n\
was specified in the basin library, as will their units.\n\
\n\
In Wheeler mode, when isotope data is displayed it is not only used for coloring\n\
but also has its curve drawn on the right side, along with the sealevel.  It\n\
uses the same purple baseline as the sealevel; the curve is drawn in green,\n\
with a line sticking out to the left of the baseline (near the bottom) with\n\
a caption indicating the scale of the isotope curve."},

  {"accum",
"A type of <fill> data, available only in Wheeler mode.  It is the\n\
accumulation at each point.\n\
\n\
Also see the \"data mapping\" and \"axis\" help entries."},

{"max accum",
   "A type of <fill> data, available only in Wheeler mode.\n\
This records the highest accumulation rate each point has had.\n\
It is most useful to give a sense of the deposition rates in the past\n\
in regions that are presently unconformities.  In Wheeler terminology,\n\
the parameter shows the deposition rate within the degradational vacuities\n\
(and, of course, outside them).\n\
\n\
Also see the \"data mapping\" and \"axis\" help entries."},

{"<axis>",
   "This button is attached to a pull-down menu that lets you select Depth\n\
(the default), Two-Way Time, or Wheeler as the vertical axis.\n\
\n\
When the axis is Wheeler the plotter displays a Wheeler diagram instead of\n\
stratigraphy.  The log menu becomes inaccessible, and the fill menu changes\n\
its selection of data.  By default the Wheeler data is water-depth data,\n\
displayed according to the rules described under 'water depth'.  The \n\
exception is the areas of zero accumulation (the 'lacunae'); light grey is\n\
used for locations where material was deposited once but has since been\n\
eroded entirely away (degradational vacuities), and dark grey for locations\n\
where deposition never occurred (hiatuses).  Of course, degradational vacuities\n\
are not indicated on a display of max accumulations.\n\
\n\
The type of data displayed outside Wheeler mode is remembered separately \n\
from the type of data displayed in wheeler mode; altering one does not\n\
affect the other.  Two-Way Time and Depth are not separated in this fashion.\n\
\n\
The Wheeler diagram is drawn from the _bottom_, so you will probably \n\
have to thumb the vertical scrollbar down to see it, depending on how\n\
much you display.  The 'wheeler uses' aspect of the parameters window\n\
sets how much of the full graph (which is bigger than the visible \n\
area, remember) the oldest Wheeler diagram takes up vertically; it \n\
defaults to 50%.  Ten horizontal lines appear at equal intervals on \n\
the Wheeler diagram, with numbers at their left ends; the number is \n\
the age of that position.  On the right side the sealevel is plotted \n\
in light blue across a purple baseline; a line sticks out to the left \n\
from this baseline, with a caption indicating the scale of the sealevel.\n\
Note that when isotope data is present and displayed it uses the same\n\
baseline, albeit with its own scale line, caption, and curve."},

  {"misc",
     "This activates a pulldown menu with some two-state options; selecting\n\
an option toggles its state.  Each entry is indicative of its state.\n\
They're a mishmash of things that didn't especially go anywhere else in the\n\
control space but only had two states.\n"},

  {"timelines (misc)",
"This is an entry in the 'misc' menu.  Selecting it toggles whether the \n\
timelines are displayed (outside Wheeler mode).  The timelines are shown\n\
initially.\n"},

  {"shoreline (misc)",
"This is an entry in the 'misc' menu.  Selecting it toggles whether the \n\
shoreline will be plotted.  Initially it is not."},

  {"ricker wave (misc)",
"Toggles between ricker displacement and ricker velocity as the form of\n\
the seismic signal wavelet; see the entry for 'signal' data.\n"},
  
  {"logs (misc)",
     "This affects the display of the logs other than the seismic signal.\n\
(use the <sig> entry in <misc> for that.)  Both forms, 'curve' and 'area,'\n\
graph the datum out from a baseline at each node for which the log is to be\n\
plotted (as specified in the parameters window).  The graph is of constant\n\
color, depending on the datum but not on its values.  'Curve' just makes the\n\
outline; 'area' fills in the area between the curve and the baseline.  In\n\
either case the amplitude is controlled by the number box next to the <log>\n\
control in the main console.\n"},
  
  {"sig (misc)",
     "This affects the display of the signal log and nothing else.  As\n\
red/blue (the default), the signal is plotted as blue to the right of the\n\
baseline when positive, and red to the left of the baseline when negative.\n\
In either case the curve is filled in with the color, not outlined.\n\
\n\
When the signal is area/curve, it is plotted as a white curve outlined\n\
in black to the right when positive, and a filled-in black curve to the left\n\
when negative.\n"},
 
  {"reflec coeffs (misc)",
  "When specified to be visible, the reflection coefficients are shown\n\
as short grey line segments whose length and direction indicate amplitude\n\
and sign of the reflection at that layer boundary.  In Twtime mode a \n\
sample line of strength 10% will be shown in the box at the upper left,\n\
with a signal wavelet around it.\n"},
  
  {"seabottom (misc)", 
   "The reflections between the sea bottom and the earth are visible\n\
when signal data is displayed if and only if this toggle is on (default is\n\
off).  Seabottom reflections tend to be considerably bigger than the others\n\
and can be distracting, especially since all signals are scaled to the \n\
largest.  This control affects both log and fill displays of signal.\n"},
  
  {"paint (misc)",
"This is an entry in the 'misc' menu.  Selecting it toggles whether the\n\
color displays will use grayscale or color.  Initially they use color.\n\
'Normal' colors, like the anglebox lines, are in color regardless; only\n\
the spectra in the colorbar are altered by this.  Toggling this will causes\n\
a redraw."},

  {"<parameters>",
"Clicking on this button causes the parameters window to pop up.  The \n\
parameters window allows the user to examine and change many of the \n\
parameters of the picture.  See the help for the parameter window for\n\
more information.\n"},

  {"<dump>",
"This lets you dump the current image to a file which can be viewed at a\n\
later time or piped through other programs to a printer.\n\
\n\
When you click on this button a menu will come up; move the mouse\n\
pointer to highlight the desired type of dump and release the button.\n\
'Entire' is a what-you-see-is-what-you-get dump.  'View' is the\n\
scrollbars and the currently-displayed area of the main canvas.\n\
'Canvas' is the entire canvas (the drawing area with the lines and\n\
all; the thing that slides back and forth in the background when\n\
you thumb the scrollbars), both the displayed section and the rest.\n\
\n\
You will then be asked for a file name to dump to.  If you specify a file\n\
with a .xwd suffix, e.g. mybasin.xwd, you will get an xwd dump; if you\n\
specify a file with a .gif suffix, e.g. mybasin.gif, you will get a gif\n\
dump.\n\
\n\
Dumping to a gif takes a bit longer than dumping with xwd, but gif files\n\
are smaller than xwd files, and you can conveniently use the xv utility (not\n\
part of Strata) to view them and send them to printers.\n\
\n\
Xwd files may be treated with various utilities; xwud (part of the X distribution)\n\
will let you view them on the screen, and xpr will send them to a printer.\n\
Read the man pages for descriptions of these, they aren't parts of Strata either.\n\
\n\
Saving the dump in <filename> automatically creates a <filename>.specs\n\
file with the various possibly-relevant parameters; these consist\n\
of what the parameter window would be telling you if you were looking\n\
at it."},

  {"<help>",
"Clicking on this button brings up the main help menu, as you have \n\
already discovered.\n"},

  {"<freeze>",
"If this toggle is on, the picture will not be redrawn even if changes \n\
are made that should alter the picture.  This allows you to change \n\
several features --- for instance, go into Wheeler mode, select \n\
'accum,' and turn color scaling on --- without having to wait for a \n\
redraw each time.  When the toggle is turned off, the picture will be\n\
redrawn if any changes were made.  You can also update the picture by\n\
clicking on the 'update' button, which will be active while freeze is\n\
on.  This will update the picture and leave you in freeze mode for \n\
further changes.  If you select a slice age while frozen, the data is\n\
loaded if it has not been already, but the picture is not redrawn.\n"},

  {"<update>",
"This button is only active when the 'freeze' toggle is on.  When \n\
clicked, it causes the picture to be updated if any changes have been\n\
made during the freeze.\n"},

  {"<exit>",
"When you click this button you will be asked to confirm or abort \n\
exiting the program.  If and only if you confirm the program will exit.\n"},

{"exit help", "exit help"}};  /* this must be the last pair */











