

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"
#include <X11/Xaw/Scrollbar.h>


/* There is a "progress bar" in the box in the lower left-hand corner, 'cause
   I wasn't using that space for anything and we wanted one.  It does a
   horizontal thermometer-like scrollbar display to show how much of a
   lengthy process is done, to let the user know how hard to twiddle 
   his/her/its thumbs. */

/* progressname():  change name of label of progress bar */
/* progressvalue():  change length of progress bar */
/* progressclear():  erase progress label, bar */


static Widget scroll_here, label_here;
static Window swin_here, lwin_here;
static Boolean init_here = False;

/* init the above static things */

void progressinit()
{
  label_here = XtNameToWidget(toplevel, "*progressbox.label");
  lwin_here = XtWindow(label_here);
  scroll_here = XtNameToWidget(toplevel, "*progressbox.scroll");
  swin_here = XtWindow(scroll_here);
  init_here = True;

  XtVaSetValues(label_here, XtNforeground, black, XtNlabel, "", NULL);
}

/* change name of label of progress bar */

void progressname(String s)
{
  if (!init_here)
    progressinit();

  XtVaSetValues(label_here, XtNlabel, (XtArgVal)s, NULL);
}

/* change the length of the progress bar */

void progressvalue(double x) /* assumes progressname() has run progressinit() */
{
  XEvent event;
 
  XawScrollbarSetThumb(scroll_here, 0.0, x);
  while (XCheckWindowEvent(display, swin_here, ExposureMask, &event) ||
         XCheckWindowEvent(display, lwin_here, ExposureMask, &event))
    XtDispatchEvent(&event);
}


/* erase progress displays */

void progressclear()
{
  progressname("");
  progressvalue(0.0);
}
