

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"
#include <X11/Xaw/Toggle.h>


extern void dealcontour(void);

int compaction;

void setaxis(Widget widget, XtPointer clientData, XtPointer callData)
{
  char name[30];
  int i, cli = (int)clientData, n, major, minor;
  int logmajor = logdata / 100;
  int logminor = logdata % 100;

  if (axismode != cli) {
    switch (axismode = cli) {
    case DEPTH:   strcpy(name, "axis: depth");  break;
    case TWTIME:  strcpy(name, "axis: twtime");  break;
    case WHEELER: strcpy(name, "axis: wheeler");  break;
    }
    XtVaSetValues(XtParent(XtParent(widget)), XtNlabel, (XtArgVal)name, NULL);
    dealcontour();
    if (wheeler != !axismode) {
      wheeler = !axismode;
      major = data[wheeler] / 100;
      minor = data[wheeler] % 100;
      
      for (i = 0; i < nchoices; ++i) {
	XtVaSetValues(datachoice[i].obj[0],
		      XtNlabel, (XtArgVal)datachoice[i].label[wheeler],
		      XtNsensitive, datachoice[i].major[wheeler] != OFF,
		      NULL);
	n = datachoice[i].major[wheeler];
	if ((!compaction && POROSITY == n) ||
	    (!condsand && (CONDUCT == n || THERM==n || THGRAD==n || TTI == n)))
	  XtSetSensitive(datachoice[i].obj[0], False);
	if (datachoice[i].major[wheeler] == major &&
	    datachoice[i].minor[wheeler] == minor)
	  sprintf(name, "fill:  %s", datachoice[i].label[wheeler]);
      }
      XtVaSetValues(filldatabtn, XtNlabel, (XtArgVal)name, NULL);
      XtVaSetValues(scalefill,
		    XtNsensitive, major != NODATA,
		    XtNstate, datascale[major][minor].scaled[0], 
		    NULL);
      XtSetSensitive(logdatabtn, !wheeler);
      XtSetSensitive(condatabtn, !wheeler);
      XtVaSetValues
	(scalelog,
	 XtNsensitive, !wheeler && logmajor != NODATA,
	 XtNstate, !wheeler && datascale[logmajor][logminor].scaled[1], 
	 NULL);
      XtSetSensitive(logampbtn, !wheeler && logmajor != NODATA);
      if (!wheeler && logmajor != NODATA) {
	sprintf(name, "%d", datascale[logmajor][logminor].amp);
	XtVaSetValues(logampbtn, XtNlabel, (XtArgVal)name, NULL);
      }
    }
    picture();
  }
}


