

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"


extern void scalebars(void);
extern void setspectrum(void);

extern Boolean logdisp, sigmode, reflecmode;
extern int funcmode;  /* this is a special case, grumble, grumble */

Boolean linesvis, reflecmode, shorevis, sigvis;

void setboolean(Widget widget, XtPointer clientData, XtPointer callData)
{
  Boolean *bool = (Boolean *)clientData, needpic, needsca;
  char label[100];
  int fillmajor = data[wheeler] / 100;
  int logmajor = logdata / 100;

  if (bool != (Boolean *)&funcmode)
    *bool = !*bool;
  else
    funcmode = 1 - funcmode;   /* 0 or 1 */

  needsca = False;

  if (&linesvis == bool) {
    sprintf(label, "timelines:  %s", *bool ? "shown" : "off");
    needpic = !wheeler;
  }
  else if (&shorevis == bool) {
    sprintf(label, "shoreline:  %s", *bool ? "shown" : "off");
    needpic = True;
  }
  else if (&logdisp == bool) {
    sprintf(label, "logs:  %s", *bool ? "area" : "curve");
    needpic = !wheeler && (logmajor != NODATA) && (logmajor != SIGNAL);
  }
  else if (&sigmode == bool) {
    sprintf(label, "sig:  %s", *bool ? "black / white" : "red / blue");
    needpic = !wheeler && (SIGNAL == logmajor);
    needsca = reflecmode;
  }
  else if (&watermode == bool) {
    sprintf(label, "seabottom:  %s", *bool ? "reflect" : "ignore");
    needpic = !wheeler && ((SIGNAL == logmajor) || (SIGNAL == fillmajor)
			   || reflecmode);
  }
  else if (&reflecmode == bool) {
    sprintf(label, "reflec coeffs:  %s", *bool ?  "shown" : "off");
    needpic = !wheeler;
  }
  else if (&usecolor == bool) {
    sprintf(label, "paint:  %s", *bool ? "color" : "grey");
    needpic = False;
  }
  else if ((Boolean *)&funcmode == bool) {
    sprintf(label, "ricker %s", funcmode ? "velocity" : "displacement");
    needpic = (SIGNAL == logmajor || SIGNAL == fillmajor);
    needsca = reflecmode;
  }
  
  XtVaSetValues(widget, XtNlabel, (XtArgVal)label, NULL);
  
  if (&usecolor == bool) { 
    setspectrum();
    needpic = True;
  }
  
  if (needpic)
    picture();
  else if (needsca)
    scalebars();
}
