

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Dialog.h>


extern Widget condial, conval;

/* <return> pressed, or value needed to be used */
void setcontour(Widget w, XEvent *e, String *s, Cardinal *c)
{
  double x, y;
  char str[100];
  int major = condata / 100;
  int minor = condata % 100;
  Datascale *ds = &datascale[major][minor];

  y = ds->interval;

  if (sscanf(XawDialogGetValueString(condial), "%lf", &x) == 1)
    ds->interval = x;
  else 
    ds->interval = 0;

  if (ds->interval <= 0) {
    if (major != FACIES)
      x = ds->end[1][slice] - ds->end[0][slice];
    else
      x = ds->end[1][slice] + ds->end[0][slice];
    x *= .1;
  }

  if (x > 0) {
    sprintf(str, "%g", x);
    ds->interval = x;
  }
  else
    strcpy(str, "");

  XtVaSetValues(condial, XtNvalue, str, NULL);
  XawTextSetInsertionPoint(w, strlen(str));

  if (e != NULL && x > 0 && x != y)
    picture();
}
  
  
void dealcontour()
{
  char s[100];
  int major = condata / 100;
  int minor = condata % 100;
  Datascale *ds = &datascale[major][minor];

  if (wheeler || NODATA == major) {
    XtVaSetValues(condial, XtNvalue, "", XtNsensitive, False, NULL);
    XawTextDisplayCaret(conval, False);
  }
  else {
    XtSetSensitive(condial, True);
    XawTextDisplayCaret(conval, True);
    if (ds->interval > 0) {
      sprintf(s, "%g", ds->interval);
      XtVaSetValues(condial, XtNvalue, s, NULL);
      XawTextSetInsertionPoint(conval, strlen(s));
    }
    else {
      XtVaSetValues(condial, XtNvalue, "", NULL);
      setcontour(conval, NULL, NULL, NULL);
    }
  }
}
   
