

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"
#include <X11/Xaw/Toggle.h>


/* set what kind of data is being displayed for the current mode.
   E.g. water depth, porosity, diffusion, or none if not in Wheeler mode,
   water depth, accum, max accum, or diffusion if in Wheeler mode.  Relies
   on wheeler being a 0-or-1 Boolean. */

extern void dealcontour(void);

int logdata, condata;
int data[2];


void setdata(Widget widget, XtPointer clientData, XtPointer callData)
{
  int cli = (int)clientData, which, major, minor, dat, choice;
  char s[100], name[100];
  Widget scale;

  which = cli / 10000;  /* 0 == fill, 1 == log, 2 == contour */
  choice = cli % 10000;    

  major = datachoice[choice].major[wheeler];
  minor = datachoice[choice].minor[wheeler];
  dat = major * 100 + minor;

  switch (which) {
  case 0:  
    if (data[wheeler] != dat) {
      data[wheeler] = dat;
      scale = scalefill;
      sprintf(name, "fill");
    }
    else
      return;
    break;
  case 1:
    if (logdata != dat) {
      logdata = dat;
      scale = scalelog;
      XtSetSensitive(logampbtn, major != NODATA);
      if (dat != NODATA) {
	sprintf(s, "%d", datascale[major][minor].amp);
	XtVaSetValues(logampbtn, XtNlabel, s, NULL);
      }
      sprintf(name, "log");
    }
    else {
      picture();  /* this is how you redraw when only log amp changes */
      return;
    }
    break;
  case 2:
    if (condata != dat) {
      condata = dat;
      scale = NULL;
      dealcontour();
      sprintf(name, "contour");  
    }
    else 
      return;
    break;
  }

  if (scale)
    XtVaSetValues(scale,
		  XtNsensitive, major != NODATA, 
		  XtNstate, datascale[major][minor].scaled[which], 
		  NULL);

  sprintf(s, "%s:  %s", name, datachoice[choice].label[wheeler]);
  XtVaSetValues(XtParent(XtParent(widget)), XtNlabel, (XtArgVal)s, NULL);

  picture();
}

