
/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see strata.h                              */
#include "strata.h"
#include "license.h"

#include "globals.h"


extern void boomalloc(double ***);

double **thgrad[NSLICES];

/* only gets called once per slice */

void thermgrad()
{
  int i, j, a, b;
  double y, max, min;

  boomalloc(&thgrad[slice]);
  
  for (i = 0; i < nnodes; ++i)
    for (j = 0; j < timeloop[slice]; ++j) {
      for (a = j + 1, b = j - 1, y = 0; !y; ++a, --b) 
	if (a >= timeloop[slice] && b < 0) /* weird */
	  y = 1, a = b = j;
	else {
	  if (a >= timeloop[slice])
	    a = timeloop[slice] - 1;
	  else if (b < 0)
	    b = 0;
	  y = timeline[slice][0][a][i] - timeline[slice][0][b][i];
	}
      thgrad[slice][i][j] = 
	-(timeline[slice][5][--a][i] - timeline[slice][5][++b][i]) / y;  
    }
  
  max = min = thgrad[slice][0][0];
  for (i = 0; i < nnodes; ++i)
    for (j = 0; j < timeloop[slice]; ++j)
      if (thgrad[slice][i][j] > max)
	max = thgrad[slice][i][j];
      else if (thgrad[slice][i][j] < min)
	min = thgrad[slice][i][j];

  datascale[THGRAD][0].end[0][slice] = min;
  datascale[THGRAD][0].end[1][slice] = max;
}
