
/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris  */
/* see file strata.h */

#include "strata.h"

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include "paramheader.h"
#include "globals.h"

void defaultgroup(Group g)
{
  int i;

  for (i = 0; i < g->nelem; ++i) {
    XtFree(g->val[i]);
    g->val[i] = XtNewString(g->defval[i]);
  }
}

void defaultsome(Widget w, XtPointer clientData, XtPointer callData)
{
  int i;
  int doall = (int)clientData;   /* boolean */
  Group g = &group[curgroupnum];
  
  if (!overwriteconfirm(w, doall))
    return;

  if (doall)
    for (i = 0; i < ngroups; ++i)
      defaultgroup(group + i);
  else
    defaultgroup(g);

  setgroupvalues();
  settitle("defaults", doall);
}
