
/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris  */
/* see file strata.h */

#include "strata.h"

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include "paramheader.h"
#include "globals.h"

extern String suggestion(Boolean);
extern String myfgets(String, int, FILE *);
extern String warnchange(Boolean);
extern String warning(Boolean);

extern Widget filesub;

Boolean loadtogroup(Group g, String s, String v)
{
  int i;
  Boolean flag;

  for (i = 0, flag = False; !flag && i < g->nelem; ++i)
    if ((flag = !strcmp(g->truename[i], s))) {
      XtFree(g->val[i]);
      g->val[i] = XtNewString(v);
    }
  
  return flag;
}

Boolean loadfile(String file, Boolean doall, Widget w)
{
  FILE *fp;
  char s[100], v[100], line[1000];
  Group g = &group[curgroupnum];
  int i;
  Boolean flag;
  
  datstring(strcpy(s, file));
  if (!(fp = fopen(s, "r"))) {
    sprintf(v, "Unable to load %s for reading.", s);
    XjMessenger(w, v, False, NULL, NULL, dialog[hascaret], alsograb);
    return False;
  }
  while (myfgets(line, 1000, fp)) 
    if (sscanf(line, "%s %s", s, v) == 2)
      if (doall)
	for (i = 0, flag = False; !flag && i < ngroups; ++i)
	  flag = loadtogroup(group + i, s, v);
      else
	loadtogroup(g, s, v);
  fclose(fp);
  setgroupvalues();
  return True;
}

void loadsome(Widget widget, XtPointer clientData, XtPointer callData)
{
  int doall = (int)clientData;  /* boolean */
  char s[100], str[100];
  String t;
  Widget w = doall ? widget : filesub;

  sprintf(s, "Load to %s%s from file",
	  doall ? "all groups" : group[curgroupnum].name,
	  doall ? "" : " group");
  sprintf(str, "%s%-35s", warnchange(doall), s);

  if (XjMessenger(w, str, True, s, suggestion(doall), 
		  dialog[hascaret], alsograb)) 
    if (strlen(s)) {
      if (loadfile(s, doall, w)) { 
	settitle("()", True);
	settitle(s, doall);
	if (strlen(t = warning(doall)))
	  XjMessenger(w, t, False, NULL, NULL, dialog[hascaret], alsograb);
      }
    }
    else XjMessenger(w, "File unspecified --- unloaded", False, 
		     NULL, NULL, dialog[hascaret], alsograb);
}

void callloadsome(Widget w, XEvent *e, String *s, Cardinal *c)
{
  int n;

  sscanf(*s, "%d", &n);

  loadsome(w, NULL, (XtPointer)n);
}
