
/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris  */
/* see file strata.h */

#include "strata.h"

#include <stdio.h>
#include <string.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Dialog.h>

#include "paramheader.h"
#include "globals.h"


Boolean *anychange;
static char warnchange_warn[] = "Warning:  changes made:  may lose data\n";
static char warnchange_safe[] = "";
String warnchange(Boolean overall)
{
  int i;

  if (overall)
    for (i = 0; i < ngroups; ++i)
      if (anychange[i])
	return warnchange_warn;

  if (anychange[curgroupnum])
    return warnchange_warn;

  return warnchange_safe;
}

Boolean overwriteconfirm(Widget w, Boolean overall)
{
  String s = warnchange(overall);

  if (s[0])
    return XjMessenger(w, s, True, NULL, NULL, dialog[hascaret], alsograb);
  else
    return True;
}

void datstring(char s[])
{
  int n;
  
  if (((n = strlen(s)) < 5) || strcmp(s + n - 4, ".dat"))
    strcat(s, ".dat");
}

void getgroupvalues()
{
  int i;
  Group g = &group[curgroupnum];
  String s;

  for (i = 0; i < g->nelem; ++i) {
    XtFree(g->val[i]); 
    s = XawDialogGetValueString(dialog[i]);
    g->val[i] = XtNewString(s);

  }
}


void setgroupvalues()
{
  int i;
  Group g = &group[curgroupnum];
  
  for (i = 0; i < g->nelem; ++i) {
    XtVaSetValues(dialog[i], XtNvalue, g->val[i], NULL);
    if (!(hascaret != i))
      XawTextSetInsertionPoint(XtNameToWidget(dialog[i], "value"),
			       strlen(g->val[i]));
  }
}

String myfgets(String s, int length, FILE *fp)
{
  String result;
  int n;
  
  result = fgets(s, length, fp);
  if ('\n' == s[n = strlen(s) - 1])
    s[n] = '\0';

  return result;
}

void mybeep(Widget w, XEvent *e, String *s, Cardinal *c)
{
  XBell(display, 50);
}


Group idtogroup(UniqueID id)
{
  int n;

  for (n = 0; groupid[n] != id && n < ngroups; ++n);

  if (n < ngroups)
    return &group[n];
  else {
    printf("Fatal code error:  no group with ID %d.  Setbasin exiting.\n", id);
    exit(1);
  } 
}

String idtoval(Group g, UniqueID id)
{
  int n;

  for (n = 0; g->id[n] != id && n < g->nelem; ++n);
  
  if (n < g->nelem)
    return g->val[n];
  else {
    printf("Fatal code error:  %s group has no element with ID %d.\n",
	   g->name, id);
    printf("Setbasin exiting.\n");
    exit(2);
  }
}
