
/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris  */
/* see file strata.h */

#include "strata.h"


/* params.h has to mention the variables that simbasin wants, and
   setbasin uses the same params.h file, so setbasin has to define
   the variables so it won't reject params.h.  In addition, the
   setbasin converter has to know all the variables of Simbasin 2.0
   so it can load old libraries to convert, so the old vars have
   to be in here (and with the correct types).    */


double fullspace, doublennodes, fulltime, doublethrust, doublentlines;
double cut[7], ksed, kmarine, lambdadif, pelagic, carbepeiricsur;
double carbepeiricdep, carboceanicsur, carboceanicsca, carboceanicdep;
double start, depth, amplitude, period;
double flex, da, dc, dm, dw, g, cshale, phi0_shale, csand, phi0_sand;
double compcut, compdecay, sandtherm, shaletherm, fluidtherm;
double surtemp, surtempfall;
double isostart;

/* new string vars */
char stringmarine[100], fluxleftstring[100], fluxrightstring[100];
char subsidencestring[100], compensatestring[100], compactionstring[100];
char erosionstring[100], thermalstring[100], skimstring[100];

/* new & old string vars */
char carbonatefile[100], eustaticfile[100], profile[100];

/* purely old string vars; need to be able to read them to convert */
char fluxfileleft[100], fluxfileright[100];
char subsidencefile[100], thermfile[100];
char isotopefile[100];

/* old var booleans */
int marine, compensate, erosion, compaction;

/* old var doubles */
double sub, thermflux, fluxleft, fluxright;


extern char f[], s[];
char d[] = "%d";

struct {
  char *format;
  void *var;
} oldvar[] = {
  {f, &fullspace},
  {f, &doublennodes},
  {f, &fulltime},
  {f, &doublethrust},
  {f, &doublentlines},
  {f, cut+1},
  {f, cut+2},
  {f, cut+3},
  {f, cut+4},
  {f, cut+5},
  {f, cut+6},
  {f, &ksed},
  {d, &marine},
  {f, &kmarine},
  {f, &lambdadif},
  {s, fluxfileleft},
  {f, &fluxleft},
  {s, fluxfileright},
  {f, &fluxright},
  {f, &pelagic},
  {s, carbonatefile},
  {f, &carbepeiricsur},
  {f, &carbepeiricdep},
  {f, &carboceanicsur},
  {f, &carboceanicsca},
  {f, &carboceanicdep},
  {s, eustaticfile},
  {f, &start},
  {f, &depth},
  {f, &amplitude},
  {f, &period},
  {s, subsidencefile},
  {f, &sub},
  {s, profile},
  {d, &compensate},
  {f, &flex},
  {f, &da},
  {f, &dc},
  {f, &dm},
  {f, &g},
  {d, &compaction},
  {d, &erosion},
  {f, &cshale},
  {f, &phi0_shale},
  {f, &csand},
  {f, &phi0_sand},
  {f, &compcut},
  {f, &compdecay},
  {s, thermfile},
  {f, &thermflux},
  {f, &sandtherm},
  {f, &shaletherm},
  {f, &fluidtherm},
  {f, &surtemp},
  {f, &surtempfall}
};
