
/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris  */
/* see file strata.h */

#include "strata.h"

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include "paramheader.h"
#include "globals.h"

extern String suggestion(Boolean);
extern String warning(Boolean);

extern Widget filesub;

void savegroup(FILE *fp, Group g)
{
  int i;

  for (i = 0; i < g->nelem; ++i)
    if (strlen(g->val[i]))
      fprintf(fp, "%-30s  %s\n", g->truename[i], g->val[i]); 
}

void savesome(Widget widget, XtPointer clientData, XtPointer callData)
{
  int i;
  FILE *fp;
  char s[100], str[10000];
  int doall = (int)clientData;  /* boolean */
  Group g = &group[curgroupnum];
  Widget w = doall ? widget : filesub;

  sprintf(s, "%s%s as",
	  doall ? "all groups" : g->name, 
	  doall ? "" : " group");
  sprintf(str, "%sSave %-30s", warning(doall), s);

  if (XjMessenger(w, str, True, s, suggestion(doall), 
		  dialog[hascaret], alsograb))
    if (strlen(s)) {
      getgroupvalues();
      /* call warn routine */
      datstring(s);
      if (!(fp = fopen(s, "w"))) {
	sprintf(str, "Unable to open %s for writing.", s);
	XjMessenger(w, str, False, NULL, NULL, dialog[hascaret], alsograb);
	return;
      }
      if (doall)
	for (i = 0; i < ngroups; ++i)
	  savegroup(fp, group+i);
      else
	savegroup(fp, g);
      fclose(fp);
      settitle("()", True);
      settitle(s, doall);
    }
    else XjMessenger(w, "File unspecified --- unsaved", False, NULL,
		     NULL, dialog[hascaret], alsograb);
}

void callsavesome(Widget w, XEvent *e, String *s, Cardinal *c)
{
  int n;

  sscanf(*s, "%d", &n);

  savesome(w, NULL, (XtPointer)n);
}
