
/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris  */
/* see file strata.h */

#include "strata.h"

#include <stdio.h>
#include <math.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/MenuButton.h>
#include "paramheader.h"
#include "globals.h"

extern void agegroup(void);
extern void docaret(int);
extern Boolean stringtobool(String);
extern void sethelptext(Widget, XtPointer, XtPointer);

extern Widget sublabel, helpsub, special_button, carbshell, needlabel;
extern Widget grouplist;
extern String *menuname;
extern Boolean iscarbgraphup;

void changegroup(int n)
{
  int i;
  Group g, old;
  char s[100];
  
  getgroupvalues();

  old = &group[curgroupnum];
  g = &group[n];
  for (i = g->nelem; i < old->nelem; ++i)
    XtVaSetValues(dialog[i], XtNmappedWhenManaged, False, NULL);

  curgroupnum = n;

  /* do special things, if any */
  switch (groupid[curgroupnum]) {
  case AgeGroup:
    agegroup();
    break;
  default:
    break;
  }
  
  for (i = 0; i < g->nelem; ++i)
    XtVaSetValues(dialog[i], 
		  XtNlabel, g->elem[i],
		  XtNvalue, g->val[i], 
		  XtNmappedWhenManaged, True,
		  NULL);

  XtVaSetValues(needlabel, XtNlabel, 
		g->need ? "Mandatory" : " Optional ", NULL);
  XtVaSetValues(sublabel, XtNlabel, g->name, NULL);
  XtVaSetValues(special_button, 
		XtNmappedWhenManaged, CarbGroup == groupid[curgroupnum],
		NULL);
  sprintf(s, "<BtnDown> : reset() placemenu() XtMenuPopup(%s)", 
	  menuname[curgroupnum]);
  XtOverrideTranslations(helpsub, XtParseTranslationTable(s));

  settitle(NULL, False);

  sethelptext(NULL, (XtPointer)0, NULL);

  docaret(0);

  if (iscarbgraphup && curgroupnum != CarbGroup)
    XtPopdown(carbshell);
}
  
void agegroup(void)
{
  int i, k, u;
  double x, units;
  char s[100];
  Group age = idtogroup(AgeGroup);

  if (stringtobool(idtoval(age, EvenAges))) 
    if (sscanf(idtoval(idtogroup(MeasureGroup), TotalTime), "%lf", &x) == 1)
      if (x > 0) {
	units = pow(10.0, 3.0 * (((int)log10(x)) / 3));
	u = log10(units);
	for (k = 0, i = 0; i < age->nelem; ++i)
	  if (Age1 == age->id[i] || Age2 == age->id[i] || Age3 == age->id[i] ||
	      Age4 == age->id[i] || Age5 == age->id[i] || Age6 == age->id[i]) {
	    sprintf(s, "%.2fe%d", ++k * x / (6 * units), u);
	    XtFree(age->val[i]);
	    age->val[i] = XtNewString(s);
	  }
      }
  
  if (AgeGroup == groupid[curgroupnum])
    setgroupvalues();
}


void selectgroup(Widget w, XtPointer clientData, XtPointer callData)
{
  int n;

  if ((n = XawListShowCurrent(grouplist)->list_index) != curgroupnum)
    changegroup(n);
}
  
void shiftgroup(Widget w, XEvent *e, String *s, Cardinal *c)
{
  int shift, n;
  int cur = XawListShowCurrent(grouplist)->list_index;

  sscanf(*s, "%d", &shift);

  n = (cur + shift + ngroups) % ngroups;
  
  XawListHighlight(grouplist, n);

  changegroup(n);
}
