
/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris  */
/* see file strata.h */

#include "strata.h"

#include <stdio.h>
#include <string.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

#include "paramheader.h"
#include "globals.h"

String *title;  /* [ngroups + 1]; last is overall */
extern Widget subtitle;
extern Boolean *anychange;

void do_settitle(String t, int n, Boolean up)
{
  char s[500];

  if (t) 
    if (strcmp(t, "()")) {
      XtFree(title[n]);
      undatstring(strcpy(s, t));
      title[n] = XtNewString(s);
    }  
    else 
      if (title[n][0] != '(') {
	sprintf(s, "(%s)", title[n]);
	XtFree(title[n]);
	title[n] = XtNewString(s);
      }
      else
	return;   
  
  if (up)
    if (n < ngroups && subtitle)
      XtVaSetValues(subtitle, XtNlabel, title[n], NULL);
    else {
      sprintf(s, "Strata Setbasin %s", title[n]);
      XtVaSetValues(toplevel, XtNtitle, s, NULL);
    }
}
  
void settitle(String t, Boolean overall)
{
  int i;

  do_settitle(t, overall ? ngroups : curgroupnum, True);

  if (t)
    if (!(anychange[curgroupnum] = !strcmp(t, "()")))
      if (overall)
	for (i = 0; i < ngroups; ++i)
	  do_settitle(t, i, i == curgroupnum);
}


char suggestion_return_string[200];
String suggestion(Boolean overall)
{
  int n = overall ? ngroups : curgroupnum;

  if (strcmp(title[n], "defaults") && strcmp(title[n], "(defaults)"))
    if (title[n][0] != '(')
      return strcpy(suggestion_return_string, title[n]);
    else {
      strcpy(suggestion_return_string, title[n] + 1);
      suggestion_return_string[strlen(title[n]) - 2] = '\0';
      return suggestion_return_string;
    }
  else
    return NULL;
}


void undatstring(char s[])
{
  int n;
  
  if ((n = strlen(s)) > 4)
    if (!strcasecmp(s + n - 4, ".dat"))
      s[n - 4] = '\0';
}
