
/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris  */
/* see file strata.h */

#include "strata.h"

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include "paramheader.h"
#include "globals.h"

extern Boolean blank(String);

static char varwarning_string[100];
static String varwarning(Group g, int n)
{
  strcpy(varwarning_string, "");

  if (blank(g->val[n])) {
    if (g->need)
      sprintf(varwarning_string, "Warning:  mandatory item %s    no value\n",
	      g->elem[n]);
  }
  else
    if (!g->ok[n](g->val[n]))
      sprintf(varwarning_string, "Warning:  restricted item %s  bad value\n", 
	      g->elem[n]);
  
  return varwarning_string;
}
  
static char groupwarning_string[2000];
static String groupwarnings(Group g)
{
  int i;
  
  strcpy(groupwarning_string, "");
  
  for (i = 0; i < g->nelem; ++i)
    strcat(groupwarning_string, varwarning(g, i));

  return groupwarning_string;
}

static char warning_string[10000];
String warning(Boolean doall)
{
  int i;

  getgroupvalues();

  strcpy(warning_string, "");
  
  if (doall)
    for (i = 0; i < ngroups; ++i)
      strcat(warning_string, groupwarnings(group+i));
  else
    strcpy(warning_string, groupwarnings(group+curgroupnum));

  return warning_string;
}

void warnsome(Widget w, XtPointer clientData, XtPointer callData)
{
  int doall = (int)clientData;  /* boolean */
  String s;

  XjMessenger(w, (strlen(s = warning(doall)) ? s : "No warnings."),
	      False, NULL, NULL, dialog[hascaret], alsograb);
}
  


