

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see file strata.h                                                 */
#include "strata.h"

#define streq(s, t) !strcasecmp(s, t)


Boolean fine(String s)
{
  return True;
}

Boolean notfine(String s)
{
  return False;
}

Boolean unsure(String s)
{
  return True;
}

Boolean blank(String s)
{
  return (strspn(s, " ") == strlen(s));
}

Boolean isadouble(String s)
{
  double x;
  int n;

  sscanf(s, "%lf%n", &x, &n);
  return (strlen(s) == n);
}

Boolean posdef(String s)
{
  double x;

  if (!isadouble(s))
    return False;

  sscanf(s, "%lf", &x);
  return (x > 0);
}

Boolean nonneg(String s)
{
  double x;

  if (!isadouble(s))
    return False;

  sscanf(s, "%lf", &x);
  return (x >= 0);
}

Boolean nonpos(String s)
{
  double x;

  if (!isadouble(s))
    return False;

  sscanf(s, "%lf", &x);
  return (x <= 0);
}

Boolean isfraction(String s)
{
  double x;

  if (!isadouble(s))
    return False;

  sscanf(s, "%lf", &x);
  return (x >= 0 && x <= 1);
}  

Boolean isanint(String s)
{
  int n, x;

  sscanf(s, "%d%n", &x, &n);
  return (strlen(s) == n);
}

Boolean posint(String s)
{
  return (posdef(s) && isanint(s));
}

Boolean bool(String s)
{
  return  (streq(s, "1") || streq(s, "0") ||
	   streq(s, "True") || streq(s, "False") ||
	   streq(s, "T") || streq(s, "F") ||
	   streq(s, "Yes") || streq(s, "No") ||
	   streq(s, "Y") || streq(s, "N") ||
	   streq(s, "On") || streq(s, "Off"));
}

/* not really a *warning* function, but what the hell... */
Boolean stringtobool(String s)
{
  return (streq(s, "1") ||
	  streq(s, "True") || 
	  streq(s, "T") ||
	  streq(s, "Yes") ||
	  streq(s, "Y") ||
	  streq(s, "On"));
}

Boolean testprofile(String s)
{
  return (streq(s, "passive") || 
	  streq(s, "foreland") ||
	  streq(s, "cratonic"));
}
