/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris  */
/* see file strata.h */
#include "strata.h"


/*    This needs to be the SAME file in simbasin and setbasin!  */


#ifndef __HEADER_ALREADY_INCLUDED
#define __HEADER_ALREADY_INCLUDED


typedef enum {
       GeneralID = 0,
       MeasureGroup,
  TotalWidth, SpatialDiv, TotalTime, TimeDiv, NumTimelines,
       AgeGroup,
  EvenAges, Age1, Age2, Age3, Age4, Age5, Age6,
       ClasticGroup,
  NonmarineDiffus, MarineSed, MarineDiffus, MarineDecay, LeftFlux, RightFlux, 
  Pelagic,
       CarbGroup,
  CarbFile, EpeiricMax, EpeiricDepth, OceanicMax, OceanicDecay, OceanicDepth,
  Skim, Isotopes, IsoTime,
       SeaGroup, 
  SeaFile, SeaTime, SeaDatum, SeaAmp, SeaPeriod,
       SubsidGroup,
  SubsidDrive, Profile, FlexComp, FlexRigid, DenseAir, DenseCrust, 
  DenseMantle, DenseWater, Grav,
       CompactGroup,
  CompactSed, ErodeCompact, ShaleDecay, ShalePhi, SandDecay, SandPhi,
  SandCutoff, CompDecay,
       HeatGroup,
  ThermalFlux, SandConduct, ShaleConduct, FluidConduct, SurfaceTemp, TempFall
} UniqueID;

#define MAXPERGROUP 50
struct groupstruct {
  String name;
  int nelem;
  String elem[MAXPERGROUP];
  String truename[MAXPERGROUP];
  String val[MAXPERGROUP];
  String defval[MAXPERGROUP];
  UniqueID id[MAXPERGROUP];
  Boolean (*ok[MAXPERGROUP])(String);
  Boolean need;    /* from groupname's !ok(groupname) */
};
typedef struct groupstruct * Group;
#undef MAXPERGROUP

extern char Endgroups[], Newgroup[], NoFile[];
extern char MeasureName[], AgeName[], ClasticName[], CarbonateName[];
extern char SeaName[], SubsidenceName[], CompactionName[], HeatName[];

#endif
