

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see file strata.h                                                 */
#include "strata.h"


/* apply loads present in nodal array elev(*) to infinite elastic beam
   by multiplying the magnitude of the load in elev by the unit displacement
   nodal array disp in a double loop. */

#include <stdio.h>
#include <stdlib.h>
#include "header.h"

double *compen = NULL;
double *waterload;
double *newwaterthick, *oldwaterthick;
double *load, *waterload;
double *elev, *chelev;
double dw;

void barncomp(void)
{
  int i, j;

  if (!compen)
    compen = (double *) calloc(nnodes, sizeof(double));

  for (i = 0; i < nnodes; ++i) {
    compen[i] = 0;
    load[i] = dc * g * chelev[i] * delta;  
  }

  if (marine) 
    for (i = 0; i < nnodes; ++i) {
      newwaterthick[i] = ((elev[i] < waterlevel) ? -elev[i] : 0);
      waterload[i] = dw * g * (newwaterthick[i] - oldwaterthick[i]) * delta;
      load[i] += waterload[i];
      oldwaterthick[i] = newwaterthick[i];
    }

  if (flex)
    for (i = 0; i < nnodes; ++i) 
      for (j = 0; j < nnodes; ++j) 
	compen[j] += load[i] * disp[abs(i - j)];
  else
    for (i = 0; i < nnodes; ++i)
      compen[i] -= load[i] / (delta * g * (dm - da));

  for (i = 0; i < nnodes; ++i) {
    elev[i] += compen[i];
    chelev[i] = 0;
    tchelev[i] += compen[i];
  }
}
  
