
/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see file strata.h                                                 */
#include "strata.h"


#include <stdio.h>
#include <stdlib.h>
#include "header.h"

double carbepeiricdep, carbepeiricsur;
double carboceanicdep, carboceanicsca, carboceanicsur;
double *carblagdepth, *carblagtime, *carbpos;
char carbonatefile[100], *carbtype;
  
/* carbread.c */
void carbread(void)
{
  int i;
  FILE *fp;
  Boolean missep, missoc, badtype;

  fp = openfile(carbonatefile);

  /* no carbonates at far left */
  carbpos = (double *) calloc(1, sizeof(double));
  carbtype = (char *) calloc(1, sizeof(char));
  carblagtime =  (double *) calloc(1, sizeof(double));
  carblagdepth =  (double *) calloc(1, sizeof(double));

  /* sscanf'ing these breaks on some idiot machines */
  carbpos[0] = -1;
  carbtype[0] = 'N';
  carblagtime[0] = 0;
  carblagdepth[0] = 0;

  i = 0;

  do {
    ++i;
    carbpos = (double *) realloc(carbpos, (i+1) * sizeof(double));
    carbtype = (char *) realloc(carbtype, (i+1) * sizeof(char));
    carblagtime = (double *) realloc(carblagtime, (i+1) * sizeof(double));
    carblagdepth = (double *) realloc(carblagdepth, (i+1) * sizeof(double));
  } while (fscanf(fp, "%lf %c %lf %lf", carbpos+i, carbtype+i, carblagtime+i, 
		  carblagdepth+i) == 4 && carbpos[i] != -1);
  /* the -1 termination option is for back compatibility */

  /* no carbonates at far right */
  carbpos[i] = 2 * nnodes * delta;
  carbtype[i] = 'N';
  carblagtime[i] = 0;
  carblagdepth[i] = 0;

  fclose(fp);

  missep = missoc = badtype = False;
  while (--i)
    if ('E' == carbtype[i])
      missep |= (!carbepeiricsur || !carbepeiricdep);
    else if ('O' == carbtype[i])
      missoc |= (!carboceanicsur || !carboceanicdep || !carboceanicsca);
    else 
      badtype |= (carbtype[i] != 'N');

  if (missep)
    printf("Carbonate file %s includes epeirics; epeiric variables needed.\n",
	   carbonatefile);
  if (missoc)
    printf("Carbonate file %s includes oceanics; oceanic variables needed.\n",
	   carbonatefile);
  if (badtype)
    printf("Carbonate file %s includes unknown type (not E, O, nor N).\n",
	   carbonatefile);
  
  if (missep || missoc || badtype) {
    printf("Carbonate errors fatal.  Exiting.\n");
    exit(1);
  }
}
