
/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see file strata.h                                                 */
#include "strata.h"


#define MODEL 0   /* simbasin is defined to be model 0 */

/* Patch history, starting from v2.1:
   2.11:  
          carbread() correctly terminates on a line starting with -1,
	  for compatibility with v2.0 carb files, which were all supposed
	  to terminate that way (in v2.1 no special termination is needed)
   2.12:
          oops, testing lines were left in carbread() to spit out
	  the carb specs, then exit().  removed.
   2.13:
          'skim' carbonate option added
	  movie handshaking tightened up
	  void main() --> int returning 0

   2.14:
          headers shared with setbasin moved to src/shared
	  isotope tracking added
	  #temporal divisions % #timelines must == 0
*/


typedef int Boolean;
typedef char * String;
typedef char Tempstring[100];

#ifndef False
#define False 0
#define True 1
#endif

#ifndef FALSE
#define FALSE 0
#define TRUE 1
#endif

extern char NoFile[];
extern char ExxonSea[];

extern char *myfgets(char *, int, FILE *);
extern FILE *openfile(char *);

/* A few too many of these are global... some should be externs on one or
   two routines, and some should just be passed around.  */

extern double *aa[3];
extern double amplitude;
extern double *bb[3];
extern double carbepeiricdep;
extern double carbepeiricsur;
extern double *carblagdepth; 
extern double *carblagtime;
extern double carboceanicdep;
extern double carboceanicsca;
extern double carboceanicsur;
extern char carbonatefile[100];
extern double *carbpos;
extern char *carbtype;
extern double csand;
extern double cshale;
extern Boolean compaction;
extern double compcut;     /* composition cutoff water depth */
extern double compdecay;   /* composition decay constant */
extern Boolean compensate;              
extern double cut[7];
extern Boolean *cutoff;
extern double da, dc, dm, dw;
extern double delta;
extern double depth;
extern double *difconst;
extern double *disp;
extern double *elev, *chelev;
extern Boolean erosion;    /* whether compaction should correct for erosion */
extern char eustaticfile[100];
extern double *exposed;
extern double flex;
extern double fluidtherm;
extern double fluxleft, fluxright;
extern char fluxfileleft[], fluxfileright[];
extern double fullspace;
extern double fulltime;
extern double g;
extern double highfluxleft, highfluxright;
extern double highfluxtimeleft, highfluxtimeright;
extern double highsea;
extern double highseatime;
extern double hightherm;
extern double highthermtime;
extern char isotopefile[1000];
extern double kmarine;
extern double ksed;
extern double lambdadif;
extern char library[1000];
extern double *load;
extern double lowfluxleft, lowfluxright;
extern double lowfluxtimeleft, lowfluxtimeright;
extern double lowsea;
extern double lowseatime;
extern double lowtherm;
extern double lowthermtime;
extern Boolean marine;
extern double **maxspace;
extern Boolean movie;                   /* movie ? */
extern double *newwaterthick;
extern int nframes;                 /* # of movie frames */
extern int nnodes;
extern int ntlines;
extern double *oldwaterthick;
extern double pelagic;
extern double period;
extern double phi0_sand;
extern double phi0_shale;
extern char profile[20];
extern double sandtherm;
extern double *sealevel;
extern char seatype[12];
extern double seawave[][5];
extern double shaletherm;
extern int *shoreboundary;
extern int shoreline;
extern double start;
extern double sub;
extern double *subsid;
extern char subsidencefile[100];
extern double surtemp;
extern double surtempfall;
extern double *tchelev;
extern Boolean thermdo;
extern char thermfile[100];
extern double thermflux;
extern int thrust;
extern double time1;
extern double timedelt;
extern double **timeline[7];
extern int timeloop[7];
extern int tlstep;
extern double waterlevel;
extern double *waterload;
extern double **well[2];
extern double *xx;

