

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see file strata.h                                                 */
#include "strata.h"


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "header.h"

double amplitude;
double depth;
char eustaticfile[100];
double kmarine, ksed;
double lambdadif;
double lowsea, highsea;
double lowseatime, highseatime;
char seatype[12];
double seawave[1000][5];
double waterlevel;
double period;
double start;
int shoreline;
Boolean marine;

void reprop(FILE *fpsea)
{
  int i;
  double seatime = time1 + start;
  double x;

  if (strcasecmp(eustaticfile, NoFile)) {
    if (seatype[0] == 'P') {
      while(seatime < lowseatime || seatime > highseatime) {
        lowseatime = highseatime;
        lowsea = highsea;
        if (fscanf(fpsea, "%lf %lf", &highseatime, &highsea) != 2) {
	  highseatime = lowseatime + fulltime;
	  highsea = lowsea;
	}
      }
      waterlevel =
        lowsea + (highsea - lowsea) * 
	  (seatime - lowseatime) / (highseatime - lowseatime);
    }
    else { /* seatype[0] == 'W', waves */ 
      waterlevel = depth;
      for (i = 0; seawave[i][2]; i++) 
	if (seatime >= seawave[i][0] && seatime <= seawave[i][1])
          waterlevel += seawave[i][2] * 
      	    sin((2 * 3.1415926535 * 
		 (seatime + seawave[i][4])) / seawave[i][3]);
    }
  }
  else
    waterlevel = 
      depth + amplitude * sin((2 * 3.1415926535 * seatime) / period);
  
  for (i = 2; i < nnodes - 4 && elev[i] >= waterlevel; ++i);
  shoreline = i + 1;
  
  for (i = 0; i < shoreline; ++i)
    timeline[4][timeloop[0]][i] = difconst[i] = ksed;
  
  for (i = shoreline; i < nnodes; ++i) {
    if (marine)
      if (lambdadif < 0)
	difconst[i] = kmarine;
      else
	if ((x = waterlevel - elev[i]) > 0)
	  difconst[i] = kmarine + (ksed - kmarine) * exp( - lambdadif * x);
	else
	  difconst[i] = ksed;
    else
      difconst[i] = ksed;
    timeline[4][timeloop[0]][i] = difconst[i];
  }
 

  
  return;
}
