

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see file strata.h                                                 */
#include "strata.h"


/* set up the tri-diagonal matrix that is the coefficeint matrix of the next
   timestep's equations.  this matrix will be sent to solve.c, along with
   the current elevation profile to solve for the next timestep's 
   elevation profile. */

#include <stdio.h>
#include <stdlib.h>
#include "header.h"

double *aa[3];
double *difconst;

void seta(void)
{
  int i, j;
  double tperdelt, f0;

  tperdelt = timedelt / (delta * delta);

  for(i = 0; i < nnodes; ++i)
    for(j = 0; j < 3; ++j)
      aa[j][i] = 0;

  f0 = difconst[0] * tperdelt;
  aa[0][0] = f0;
  aa[1][0] = f0 + 1;
  aa[2][0] = -f0;

  f0 = difconst[nnodes-1] * tperdelt;
  aa[0][nnodes-1] = -f0;
  aa[1][nnodes-1] = f0 + 1;
  aa[2][nnodes-1] = f0;

  for(i = 1; i < nnodes - 1; ++i) {
    if (difconst[i] == difconst[i+1]) {
      f0 = difconst[i] * tperdelt;
      aa[0][i] = -difconst[i] * tperdelt;
      aa[1][i] = 2 * difconst[i] * tperdelt + 1;
      aa[2][i] = -difconst[i] * tperdelt;
    }
    else {
      aa[0][i] = -difconst[i] * tperdelt;
      aa[1][i] = 2 * ((difconst[i] + difconst[i+1]) * tperdelt / 2) + 1;
      aa[2][i] = -difconst[i+1] * tperdelt;
    }
  }
}
