

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see file strata.h                                                 */
#include "strata.h"


/* solve a tridiagonal, not necessarily symmetric, matrix */

#include <stdio.h>
#include <stdlib.h>
#include "header.h"

double *bb[3];
double *xx;

void solve(void)
{
  int i, j;

  bb[0][0] = aa[1][0];

  for (i = 1; i < nnodes; ++i) {
    bb[1][i] = aa[0][i] / bb[0][i-1];
    bb[0][i] = aa[1][i] - bb[1][i] * aa[2][i-1];
  }

  bb[2][0] = elev[0];

  for (i = 1; i < nnodes; ++i)
    bb[2][i] = elev[i] - bb[1][i] * bb[2][i-1];

  xx[nnodes-1] = bb[2][nnodes-1] / bb[0][nnodes-1];

  for (i = 1; i < nnodes; ++i) {
    j = nnodes - i - 1;
    xx[j] = (bb[2][j] - aa[2][j] * xx[j+1]) / bb[0][j];
  }
}
