
/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see file strata.h                                                 */
#include "strata.h"

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "header.h"

static double ln2_over10 = .069314718055;

double fluidtherm, sandtherm, shaletherm;
double hightherm, lowtherm;
double highthermtime, lowthermtime;
Boolean thermdo;
char thermfile[100];
double thermflux;
double surtemp, surtempfall;

void thermal(FILE *fptherm)
{
  double therm, con, difdif, persand, mgyrs, x, s;
  int i, j;

  if (fptherm) {
    while (time1 < lowthermtime || time1 > highthermtime) {
      lowthermtime = highthermtime;
      lowtherm = hightherm;
      if (fscanf(fptherm, "%lf %lf", &highthermtime, &hightherm) != 2) {
	highthermtime = lowthermtime + fulltime;
	hightherm = lowtherm;
      }
    }
    therm = lowtherm + (hightherm - lowtherm) * 
      (time1 - lowthermtime) / (highthermtime - lowthermtime);
  }
  else
    therm = thermflux;
  
  difdif = ksed - kmarine;

  mgyrs = timedelt * tlstep / 1e6;  /* Sum TTI is in megayears */

  for (i = 0; i < nnodes; ++i) {
    if ((x = waterlevel - elev[i]) > 0)
      s = surtemp - x * surtempfall;
    else
      s = surtemp;
    timeline[5][timeloop[0] - 1][i] = (s > 0 ? s : 0);
    for (j = timeloop[0] - 2; j >= 0; --j) {
      if (compcut < 0)
	persand = (timeline[4][j][i] - kmarine) / difdif;
      else if ((x = (timeline[2][j][i] - compcut)) < 0)
	persand = 1;
      else
	persand = exp(- compdecay * x);
      con = timeline[1][j][i] * fluidtherm + 
	(1 - timeline[1][j][i]) * 
	  (sandtherm * persand + shaletherm * (1 - persand));
      timeline[5][j][i] = timeline[5][j + 1][i] +
	(timeline[0][j + 1][i] - timeline[0][j][i]) * therm / con;
    }
    for (j = 0; j < timeloop[0]; ++j)
      timeline[6][j][i] += mgyrs * exp((timeline[5][j][i] - 100) *ln2_over10);
  }
}
