

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see file strata.h                                                 */
#include "strata.h"



/* generate the nodal displacements due to a pt. load. given an array of
   n nodes, the unit load i applied at n-.5.  the deflection is symmetric,
   so it is calculated to one side of the load and then copied to the other
   side of the matrix */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "header.h"

double da, dc, dm, flex, g;
double *disp;

void unitdisp(void)
{
  int i;
  double x, alpha, wnot;

  if (flex) {
    alpha = pow(4 * flex / ((dm - da) * g), .25); 
    wnot = (alpha * alpha * alpha) / (8 * flex); /* per force */
    for (i = 0; i < nnodes; ++i) {
      x = delta * i / alpha;
      disp[i] = -wnot * (cos(x) + sin(x)) * exp(-x);  
    }
  }
}
