

/* Copyright (C) 1995 P. B. Flemings, J. P. Grotzinger, J. E. Morris
   see file strata.h                                                 */
#include "strata.h"


/* read in subsidence wells if desired */

#include <stdio.h>
#include <stdlib.h>
#include "header.h"

double **well[2];
  
/* wellread.c */
void wellread(void)
{
  int i, j, nwells, n[10000];
  char ch;
  FILE *fp;
  double x;
  Boolean flag;

  fp = openfile(subsidencefile);

  nwells = 1;  /* one well before everything, duplicates first */
  do {
    flag = False;
    while (fscanf(fp, "%c", &ch) && (ch != ':'));
    fscanf(fp, "%lf", &x);
    if (x != -1) {
      flag = True;
      for (n[nwells] = 1; fscanf(fp, "%lf %*f", &x) && x; ++n[nwells]);
      ++n[nwells++];
    }
  } while (flag);
  fclose(fp);
  /* one well after everything, duplicates last */
  ++nwells;

  n[0] = n[1];
  n[nwells - 1] = n[nwells - 2];
  for (i = 0; i < 2; ++i) {
    well[i] = (double **) calloc(nwells, sizeof(double *));
    for (j = 0; j < nwells; ++j) 
      well[i][j] = (double *) calloc(n[j] + 1, sizeof(double));
  }

  fp = openfile(subsidencefile);
  for (i = 1; i < nwells - 1; ++i) {
    while (fscanf(fp, "%c", &ch) && (ch != ':'));
    fscanf(fp, "%lf", &well[0][i][0]);
    for (j = 1; j < n[i]; ++j)
      fscanf(fp, "%lf %lf", &well[0][i][j], &well[1][i][j]);
  }
  fclose(fp);

  /* copy first onto fake pre-first well */
  well[0][0][0] = -1;
  well[1][0][0] = 0;  /* gratuitious */
  for (i = 1; i < n[0]; ++i) 
    for (j = 0; j < 2; ++j)
      well[j][0][i] = well[j][1][i];

  /* copy last onto fake post-last well */
  well[0][nwells - 1][0] = 2 * nnodes * delta;
  well[1][nwells - 1][0] = 0;  /* gratuitous */
  for (i = 1; i < n[nwells - 1]; ++i)
    for (j = 0; j < 2; ++j)
      well[j][nwells - 1][i] = well[j][nwells - 2][i];

  for (i = 0; i < nwells; ++i) {
    well[0][i][n[i]] = 0;
    well[1][i][n[i]] = well[1][i][n[i]-1];

    if (well[0][i][1] != well[0][0][1]) {
      printf("Fatal error:  the wells in %s start at different times.\n",
	     subsidencefile);
      exit(1);
    }
  }
}



